package de.tuberlin.tfs.ocl.metamodel.expressions;

import java.util.*;
// import de.tuberlin.tfs.ocl.metamodel.types.*;
import de.tuberlin.tfs.ocl.metamodel.converter.*;
// import ru.novosoft.uml.foundation.core.*;
// import ru.novosoft.uml.foundation.data_types.*;
import ru.novosoft.uml.behavior.common_behavior.*;


public class MOclMessageExpImpl extends MOclExpressionImpl implements MOclMessageExp {

	protected ArrayList arguments;
	protected MOclExpression target;
	protected MCallAction calledOperation;
	protected MSendAction sentSignal;


	/** Getter for property arguments.
	 */
	public List getArguments() {
		if( this.arguments == null) {
			return new ArrayList();
		}
		ArrayList l = new ArrayList();
		Iterator i = this.arguments.iterator();
		while(i.hasNext()) {
			l.add(i.next());
		}
		return l;
	}

	/** Setter for property arguments.
	 */
	public void  setArguments(List arguments) {
		//maybe unset some link Information ????

		this.arguments = new ArrayList();
		Iterator i = arguments.iterator();
		while(i.hasNext()) {
			this.arguments.add(i.next());
		}
	}

	/** Adder for property arguments.
	 */
	public void addArguments(MOclMessageArg arguments) {
		if(this.arguments == null) {
			this.arguments = new ArrayList();
		}
		this.arguments.add(arguments);
		//arguments.internalSetEnum(this);
	}

	/** Remover for property arguments.
	 */
	public void removeArguments(MOclMessageArg arguments) {
		if(this.arguments == null) {
			this.arguments = new ArrayList();
		}
		this.arguments.remove(arguments);
		//arguments.internalSetEnum(null);
	}


	/** Getter for property target.
	 * @return Value of property target.
	 */
	public MOclExpression getTarget() {
		return target;
	}

	/** Setter for property target.
	 * @param target value of property target.
	 */
	public void  setTarget(MOclExpression target) {
		this.target = target;
	}

	/** Getter for property calledOperation.
	 * @return Value of property calledOperation.
	 */
	public MCallAction getCalledOperation() {
		return calledOperation;
	}

	/** Setter for property calledOperation.
	 * @param calledOperation value of property calledOperation.
	 */
	public void  setCalledOperation(MCallAction calledOperation) {
		this.calledOperation = calledOperation;
	}

	/** Getter for property sentSignal.
	 * @return Value of property sentSignal.
	 */
	public MSendAction getSentSignal() {
		return sentSignal;
	}

	/** Setter for property sentSignal.
	 * @param sentSignal value of property sentSignal.
	 */
	public void  setSentSignal(MSendAction sentSignal) {
		this.sentSignal = sentSignal;
	}



	public String convert2OclString ()  throws NoSuchAttributeException{
		OclConverter.message("<MOclMessageExp>");

		StringBuffer strB = new StringBuffer();

		OclConverter.checkAttribute(target, "target", this);
		strB.append(target.convert2OclString() );

		if (sentSignal != null && sentSignal.getSignal() != null
		  && sentSignal.getSignal().getName() != null) {

			OclConverter.message("sentSignal found.");
			strB.append("." + sentSignal.getSignal().getName() + "()");
		}
		else OclConverter.message("no sentSignal found.");

		OclConverter.message("</MOclMessageExp>");
		return strB.toString();
	}

}
