/*
 * OclMetaModel13.java
 *
 * Created on 09/19/02, 19:09
 */

package de.tuberlin.tfs.ocl.metamodel.test;

import de.tuberlin.tfs.ocl.metamodel.expressions.*;
import de.tuberlin.tfs.ocl.metamodel.types.*;
import ru.novosoft.uml.foundation.core.*;

/**
 *
 * @author  tappeser
 */
public class OclMetaModel12 implements OclMetaModelInstance {

    /** Creates a new instance of OclMetaModel11 */
    public MOclConstraint getOclConstraint() {

		//OclConverter.setDebugMode(true);

		// Types ---------------------------------------------------------------
		// BooleanType
		MClassifier booleanType = new MClassifierImpl();
		booleanType.setName("Boolean");
		// StringType
		MClassifier stringType = new MClassifierImpl();
		stringType.setName("String");
		// PersonType
		MClassifier personType = new MClassifierImpl();
		personType.setName("Person");
		
		//----------------------------------------------------------------------
		// Variable declaration: p1
		MVariableDeclaration p1VarDecl = new MVariableDeclarationImpl();
		p1VarDecl.setType(personType);
		p1VarDecl.setVarname("p1");
		// Variable declaration: p2
		MVariableDeclaration p2VarDecl = new MVariableDeclarationImpl();
		p2VarDecl.setType(personType);
		p2VarDecl.setVarname("p2");
		// Variable declaration: Person
		MVariableDeclaration personVarDecl = new MVariableDeclarationImpl();
		personVarDecl.setType(personType);
		personVarDecl.setVarname("Person");

		//----------------------------------------------------------------------
		// Variable exp: p1
		MVariableExp p1VarExp = new MVariableExpImpl();
		p1VarExp.setType(personType);
		p1VarExp.setReferredVariable(p1VarDecl);
		// Variable exp: p2
		MVariableExp p2VarExp = new MVariableExpImpl();
		p2VarExp.setType(personType);
		p2VarExp.setReferredVariable(p2VarDecl);
		// Variable exp: Person
		MVariableExp personVarExp = new MVariableExpImpl();
		personVarExp.setType(personType);
		personVarExp.setReferredVariable(personVarDecl);

		//----------------------------------------------------------------------
		// Operation call expr.: allInstances()
		MOperationCallExp allInstOpCallExp = new MOperationCallExpImpl();
		MSetType personSetType = new MSetTypeImpl();
		personSetType.setElementType(personType);
		allInstOpCallExp.setType(personSetType);
		allInstOpCallExp.setSource(personVarExp);
		MOperation allInstOp = new MOperationImpl();
		allInstOp.setName("allInstances");
		allInstOpCallExp.setReferredOperation(allInstOp);

		//----------------------------------------------------------------------
		// Attribute: name
		MAttribute nameAttr = new MAttributeImpl();
		nameAttr.setType(stringType);
		nameAttr.setName("name");

		//----------------------------------------------------------------------
		// Attribute call exp: p1.name
		MAttributeCallExp p1nameAttrCallExp = new MAttributeCallExpImpl();
		p1nameAttrCallExp.setType(stringType);
		p1nameAttrCallExp.setReferredAttribute(nameAttr);
		p1nameAttrCallExp.setSource(p1VarExp);
		// Attribute call exp: p2.name
		MAttributeCallExp p2nameAttrCallExp = new MAttributeCallExpImpl();
		p2nameAttrCallExp.setType(stringType);
		p2nameAttrCallExp.setReferredAttribute(nameAttr);
		p2nameAttrCallExp.setSource(p2VarExp);

		//----------------------------------------------------------------------
		// Operation: <>
		MOperation neOp = new MOperationImpl();
		neOp.setName("<>");
		// Operation: implies
		MOperation implOp = new MOperationImpl();
		implOp.setName("implies");

		//----------------------------------------------------------------------
		// Operation call exp: p1<>p2 [arguments{1}]
		MOperationCallExp p1_ne_p2 = new MOperationCallExpImpl();
		p1_ne_p2.setType(booleanType);
		p1_ne_p2.setReferredOperation(neOp);
		p1_ne_p2.addArguments(p1VarExp);
		p1_ne_p2.addArguments(p2VarExp);
		// Operation call exp: p1.name<>p2.name [arguments{2}]
		MOperationCallExp p1Name_ne_p2Name = new MOperationCallExpImpl();
		p1Name_ne_p2Name.setType(booleanType);
		p1Name_ne_p2Name.setReferredOperation(neOp);
		p1Name_ne_p2Name.addArguments(p1nameAttrCallExp);
		p1Name_ne_p2Name.addArguments(p2nameAttrCallExp);

		// Operation call exp: p1<>p2 implies p1.name<>p2.name
		MOperationCallExp impliesOpCallExp = new MOperationCallExpImpl();
		impliesOpCallExp.setType(booleanType);
		impliesOpCallExp.setReferredOperation(implOp);
		impliesOpCallExp.addArguments(p1_ne_p2);
		impliesOpCallExp.addArguments(p1Name_ne_p2Name);

		//----------------------------------------------------------------------
		// Iterator exp: forall(p2 | ...)
		MIteratorExp p2IteratorExp = new MIteratorExpImpl();
		p2IteratorExp.setType(booleanType);
		p2IteratorExp.setName("forall");
		p2IteratorExp.setBody(impliesOpCallExp);
		p2IteratorExp.setIterator(p2VarDecl);
		// Iterator exp: forall(p1 | forall (p2 | ...) )
		MIteratorExp p1IteratorExp = new MIteratorExpImpl();
		p1IteratorExp.setType(booleanType);
		p1IteratorExp.setName("forall");
		p1IteratorExp.setBody(p2IteratorExp);
		p1IteratorExp.setIterator(p1VarDecl);
		p1IteratorExp.setSource(allInstOpCallExp);

		// --- OclConstraint
		MOclConstraint constraint = new MOclConstraintImpl();
		constraint.setKind(MOclConstraintKind.INV);
		constraint.setConstrainedElement(personType);
		constraint.setBody(p1IteratorExp);

		return constraint;
    }

    public String getOclString() {
        return "context Person inv: Person.allInstances()->forall(p1: Person | forall(p2: Person | p1 <> p2 implies p1.name <> p2.name)";
    }
}
