/*
 * OclMetaModel1.java
 *
 * Created on 10. Juli 2002, 16:25
 */

package de.tuberlin.tfs.ocl.metamodel.test;

import de.tuberlin.tfs.ocl.metamodel.expressions.*;
import de.tuberlin.tfs.ocl.metamodel.types.*;
import ru.novosoft.uml.foundation.core.*;
 
/**
 *
 * @author  jgusulde
 */
public class OclMetaModel2 implements OclMetaModelInstance {
    
    /** Creates a new instance of OclMetaModel1 */
    public MOclConstraint getOclConstraint() {
        // Types ---------------------------------------------------------------
        //BooleanType
        MClassifier booleanType = new MClassifierImpl();
        booleanType.setName("Boolean");
        // IntegerType
        MClassifier integerType = new MClassifierImpl();
        integerType.setName("Integer");
        // PersonType
        MClassifier personType = new MClassifierImpl();
        personType.setName("Person");
        // CompanyType
        MClassifier companyType = new MClassifierImpl();
        companyType.setName("Company");
        // SetType
        MSetType personSetType = new MSetTypeImpl();
        personSetType.setElementType(personType);
        //----------------------------------------------------------------------
        // VarialbeDeclaratin --------------------------------------------------
        // p
        MVariableDeclaration varD_p = new MVariableDeclarationImpl();
        varD_p.setVarname("p");
        varD_p.setType(personType);
        // self
        MVariableDeclaration varD_self = new MVariableDeclarationImpl();
        varD_self.setVarname("self");
        varD_self.setType(companyType);
        //----------------------------------------------------------------------
        
        
        
        // --- OclConstraint
        MOclConstraint constraint = new MOclConstraintImpl();
        constraint.setKind(MOclConstraintKind.INV);
        constraint.setName("Elder Employees");
        constraint.setConstrainedElement(companyType);
        
        // --- OperationCallExp  ->notEmpty()
        MOperationCallExp operationCallExp = new MOperationCallExpImpl();
        constraint.setBody(operationCallExp);
        operationCallExp.setType(booleanType);
        // operation
        MOperation notEmptyOperation = new MOperationImpl();
        notEmptyOperation.setName("notEmpty");
        operationCallExp.setReferredOperation(notEmptyOperation);
        

        // --- IteratorExp   (source for operationCallExp)
        MIteratorExp iteratorExp = new MIteratorExpImpl();
        operationCallExp.setSource(iteratorExp);
        iteratorExp.setAppliedProperty(operationCallExp);
        iteratorExp.setIterator(varD_p);
        //varD_p.setLoopExp(iteratorExp);  // nicht im MetaModel Vorhanden
        iteratorExp.setType(personSetType);
	iteratorExp.setName("select");
        
        //OperationCallExp  p.age > 50
        MOperationCallExp operationCallExp2 = new MOperationCallExpImpl();
        iteratorExp.setBody(operationCallExp2);
        operationCallExp2.setType(booleanType);
        MOperation greaterOperation = new MOperationImpl();
        greaterOperation.setName(">");
	operationCallExp2.setReferredOperation(greaterOperation);
        //arguments
        // 1.Argument age
        MAttributeCallExp argument1 = new MAttributeCallExpImpl();
        operationCallExp2.addArguments(argument1);
        argument1.setType(integerType);
        // attribut 1
        MAttribute attribute = new MAttributeImpl();
        attribute.setName("age");
        attribute.setType(integerType);
        argument1.setReferredAttribute(attribute);
        argument1.setParentOperation(operationCallExp2);
        // variableExp als Source von Argument 1
        MVariableExp variableExp = new MVariableExpImpl();
        argument1.setSource(variableExp);
        variableExp.setReferredVariable(varD_p);
        // 2.Argument 50
        MIntegerLiteralExp argument2 = new MIntegerLiteralExpImpl();
        operationCallExp2.addArguments(argument2);
        argument2.setName("50");
        argument2.setType(integerType);
        argument2.setParentOperation(operationCallExp2);
        
        
        // associationEndCallExp     self.employee
        MAssociationEndCallExp associationEndCallExp = new MAssociationEndCallExpImpl();
        iteratorExp.setSource(associationEndCallExp);
        associationEndCallExp.setType(personType);
        MAssociationEnd associationEnd = new MAssociationEndImpl();
        associationEndCallExp.setReferredAssociationEnd(associationEnd);
        associationEnd.setName("employee");
        MVariableExp selfVarExp = new MVariableExpImpl();
        associationEndCallExp.setSource(selfVarExp);
        selfVarExp.setReferredVariable(varD_self);
        
        return constraint;
    }
    
    public String getOclString() {
        return "context Company inv Elder Employees: self.employee->select(p: Person | p.age > 50)->notEmpty()";
    }    
}
