/*
 * OclMetaModel1.java
 *
 * Created on 10. Juli 2002, 16:25
 */

package de.tuberlin.tfs.ocl.metamodel.test;

import de.tuberlin.tfs.ocl.metamodel.expressions.*;
import de.tuberlin.tfs.ocl.metamodel.types.*;
import ru.novosoft.uml.foundation.core.*;
import de.tuberlin.tfs.ocl.metamodel.expressions.MIntegerLiteralExpImpl;
import ru.novosoft.uml.foundation.core.MAttribute;
import ru.novosoft.uml.foundation.core.MAttributeImpl;
 
/**
 *
 * @author  jgusulde
 */
public class OclMetaModel3 implements OclMetaModelInstance {
    
    /** Creates a new instance of OclMetaModel1 */
    public MOclConstraint getOclConstraint() {
        // Types ---------------------------------------------------------------
        //BooleanType
        MClassifier booleanType = new MClassifierImpl();
        booleanType.setName("Boolean");
        // IntegerType
        MClassifier integerType = new MClassifierImpl();
        integerType.setName("Integer");
        // PersonType
        MClassifier personType = new MClassifierImpl();
        personType.setName("Person");
        // CompanyType
        MClassifier bankType = new MClassifierImpl();
        bankType.setName("Bank");
       //----------------------------------------------------------------------
        // VarialbeDeclaratin --------------------------------------------------
        // self
        MVariableDeclaration varD_self = new MVariableDeclarationImpl();
        varD_self.setVarname("self");
        varD_self.setType(bankType);
        //----------------------------------------------------------------------
        
        
        
        // --- OclConstraint
        MOclConstraint constraint = new MOclConstraintImpl();
        constraint.setKind(MOclConstraintKind.INV);
        constraint.setConstrainedElement(bankType);
        
        // --- OperationCallExp
        MOperationCallExp operationCallExp = new MOperationCallExpImpl();
        constraint.setBody(operationCallExp);
        operationCallExp.setType(booleanType);
        // operation
        MOperation greaterOperation = new MOperationImpl();
        greaterOperation.setName(">");
        operationCallExp.setReferredOperation(greaterOperation);
        

        // --- argument{1} -- AttributeCallExp
        MAttributeCallExp attributeCallExp = new MAttributeCallExpImpl();
        operationCallExp.addArguments(attributeCallExp);
        attributeCallExp.setType(integerType);
        // Attribute
        MAttribute attribute = new MAttributeImpl();
        attribute.setName("age");
        attribute.setType(integerType);
        attributeCallExp.setReferredAttribute(attribute);
        // source -- MAssociationEndCallExp
        MAssociationEndCallExp associationEndCallExp = new MAssociationEndCallExpImpl();
        attributeCallExp.setSource(associationEndCallExp);
        // source -- VarialbeExp
        MVariableExp varExp = new MVariableExpImpl();
        varExp.setReferredVariable(varD_self);
        associationEndCallExp.setSource(varExp);
        // qualifier -- IntegerLiteralExp
        MIntegerLiteralExp intExp8764423 = new MIntegerLiteralExpImpl();
        intExp8764423.setName("8764423");
        intExp8764423.setType(integerType);
        associationEndCallExp.addQualifiers(intExp8764423);
        // referredAssociationEnd -- AssociatinEnd
        MAssociationEnd associationEnd = new MAssociationEndImpl();
        associationEnd.setName("customer");
        associationEnd.setType(personType);
        associationEndCallExp.setReferredAssociationEnd(associationEnd);
        
        // --- argument{2} -- IntegerLiteralExp
        MIntegerLiteralExp intExpNull = new MIntegerLiteralExpImpl();
        operationCallExp.addArguments(intExpNull);
        intExpNull.setName("0");
        intExpNull.setType(integerType);
        
        
        
        return constraint;
    }
    
    public String getOclString() {
        return "context Bank inv: self.customer[8764423].age > 0";
    }    
}
