/*
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 *
 * Contributors:
 *             Eduard Weiss
 *             Tony Modica
 *             Frank Hermann
 *             Holger Endert
 *
 */
package vocleditor.action;

import java.io.File;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.Clip;
import javax.sound.sampled.DataLine;

import org.eclipse.gef.ui.actions.EditorPartAction;
import org.eclipse.ui.IEditorPart;

import vocleditor.dialogs.ShowInfoDialog;
import VOCLModel.VOCLDiagramm;


/**
 * @author eddi
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ShowInfoAction extends EditorPartAction {
    static public String SHOW_INFO = "Action hinzu";
    private VOCLDiagramm diagramm;

    /**
     * Constructor of this action
     * @param editor - reference to the editor
     */
    public ShowInfoAction(IEditorPart editor) {
        super(editor);
        setDescription("Information");
        setText("Display information about the editor");
    }

    /** 
     * Calculates if this action is executable
     * @return - true, if this action is enabled
     */
    protected boolean calculateEnabled() {
        return getEditorPart() != null;
    }

    /**
     * Setter Method for the EditorPart
     * @param part - the EditorPart
     */
    protected void setEditorPart(IEditorPart part) {
        super.setEditorPart(part);
    }

    /**
     * Method initializes this class, i.e. sets id
     * and ToolTipText
     */
    protected void init() {
        super.init();
        setToolTipText("Impressum");
        setId(SHOW_INFO);
    }

    /**
     * Executes this action and also 
     * plays an audion file
     */
    public void run() {
        try {
        	AudioInputStream ais =
            AudioSystem.getAudioInputStream((ShowInfoAction.class).getResourceAsStream("gif/info.wav"));
            
            AudioFormat format = ais.getFormat();

            // Clip erzeugen und ffnen
            DataLine.Info info =
                new DataLine.Info(Clip.class, format,
                    ((int) ais.getFrameLength() * format.getFrameSize()));
            Clip clip = (Clip) AudioSystem.getLine(info);
            clip.open(ais);

            // So lange wird sich das sowieso niemand anhoeren
            clip.loop(100);
            clip.start();

            // Dialog aufrufen
            ShowInfoDialog.showGUI();
            clip.stop();
            clip.close();
            ais.close();
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }
}
