/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.commands.connect;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.tools.DragEditPartsTracker;

import vocleditor.edit.AssociationRoleEditPart;

/**
 * Class       :AssociationEndRoleTracker<br/>
 * Package     : vocleditor.commands.connect<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 22.05.2004<br/>
 * Description : Tracker to provide moving of AssociationEndRole
 * <br/>
 * @author vilapower
 */
public class AssociationEndRoleTracker extends DragEditPartsTracker
{

	AssociationRoleEditPart connection;

	public AssociationEndRoleTracker(EditPart source, AssociationRoleEditPart connection)
	{
		super(source);
		this.connection = connection;
	}

	protected EditPart getTargetEditPart()
	{
		return connection;
	}


}
