/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.commands.connect;



/**
 * Class       :ConnectCommand<br/>
 * Package     : vocleditor.commands.connect<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 22.05.2004<br/>
 * Description : Command to connect two ClassifierRoles with AssociationRole
 * <br/>
 * @author vilapower
 */
public class NavConnectCommand extends ConnectCommand {
	
		
	private static final String ConnectionCommand_Label = "associationRole";
	private static final String ConnectionCommand_Description = "AssociationRole connection command";

	
	
	/**
	 * @see org.eclipse.gef.commands.Command
	 */			
	public NavConnectCommand() {
		super(ConnectionCommand_Label);
	}
	
	/**
	* @see org.eclipse.gef.commands.Command#canExecute()
	*/	
	public boolean canExecute() {
		if(source==null || target==null || association==null) return false;
		if(source!=null & target!=null &association!=null){					
			if(source.eContainer()!=target.eContainer()) 
				return false;
		}
		return true;
	}
	




}