/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
 
package vocleditor.commands.delete;

import VOCLModel.ClassifierNode;
import VOCLModel.ClassifierRole;
import VOCLModel.Constraint;
import VOCLModel.Method;
import VOCLModel.NavExpContainer;
import VOCLModel.VariableDeclaration;

/**
 * @author eddi
 */
public class DeleteClassifierRole extends DeleteClassifierNode{

	
	private ClassifierRole classifier;
	/**
	 * @param constraint
	 * @param var
	 * @param parent
	 * @param delClassifier
	 */
	public DeleteClassifierRole(Constraint constraint, VariableDeclaration var, NavExpContainer parent, ClassifierNode delClassifier) {
		super(constraint, var, parent, delClassifier);
		classifier=(ClassifierRole) delClassifier;
	}

	/**
	 * Execution of this command deletes a classifierRole
	 * completely.
	 */
	public void delete() {
		Method method=(classifier).getMethod();
		if(method!=null){
			if(method.getRReturn()!=null){
				constraint.getVariableDeclaration().remove(method.getRReturn());
				variablen.add(method.getRReturn());
			}
			constraint.getVariableDeclaration().removeAll(method.getCall());
			variablen.addAll(method.getCall());
		}

	}

	/* (non-Javadoc)
	 * @see vocleditor.commands.delete.DeleteClassifierNode#addVariable()
	 */
	public void addVariable() {
		if(var!=null){
			if(var.getPredicateContainer()==null)
				constraint.getVariableDeclaration().add(var);
		}
	}

	/* (non-Javadoc)
	 * @see vocleditor.commands.delete.DeleteClassifierNode#deleteVariable()
	 */
	public void deleteVariable() {
		if(var!=null){
			if(var.getPredicateContainer()==null)
				constraint.getVariableDeclaration().add(var);
		}
	}

	/* (non-Javadoc)
	 * @see vocleditor.commands.delete.DeleteClassifierNode#deleteNode()
	 */
	public void deleteNode() {
		if(parent.getClassifierNode().contains(classifier))
			parent.getClassifierNode().remove(classifier);		
	}

	/* (non-Javadoc)
	 * @see vocleditor.commands.delete.DeleteClassifierNode#addNode()
	 */
	public void addNode() {
		parent.getClassifierNode().add(classifier);		
	}
	


}
