/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 *
 * Contributors:
 *		Eduard Weiss
 *      Tony Modica
 *      Frank Hermann
 *      Holger Endert
 *
 */
package vocleditor.dialogs;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import vocleditor.model.AttributeElement;

import java.awt.Dimension;
import java.awt.Toolkit;


/**
* This code was generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a
* for-profit company or business) then you should purchase
* a license - please visit www.cloudgarden.com for details.
*/
public class AddAttributeDialog extends org.eclipse.swt.widgets.Dialog {
    private Label variableLb;
    private Button isValue;
    private Button ApllyBtn;
    private Button CancelBtn;
    private Composite buttons;
    private Combo attType;
    private Text VarName;
    private Text nameText;
    private Label valueLb;
    private Label label1;
    private Label attName;
    private Group attDescr;
    private Shell dialogShell;
    private boolean state = false;
    private String name = "";
    private String value = "";
    private String type = "";
    private boolean isVariable = false;

    public AddAttributeDialog(Shell parent, int style) {
        super(parent, style);
    }

    public AddAttributeDialog(Shell parent, int style, String name,
        String value, String type) {
        this(parent, style);
        this.name = name;
        this.value = value;
        this.type = type;
    }


	public AddAttributeDialog(Shell parent, int style,AttributeElement attElem) {
			super(parent, style);
			this.name = attElem.getAttName();
			this.type = attElem.getType();
			setIsVariable(attElem.isVar());
			if(attElem.isVar())this.value = attElem.getVarname();
			else this.value = attElem.getValue();
	}
	
	/**
	* Opens the Dialog Shell.
	* Auto-generated code - any changes you make will disappear.
	*/
    public void open(){
		try {
			preInitGUI();
	
			Shell parent = getParent();
			dialogShell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
			dialogShell.setText(getText());
			attDescr = new Group(dialogShell,SWT.NULL);
			variableLb = new Label(attDescr,SWT.NULL);
			isValue = new Button(attDescr,SWT.CHECK| SWT.LEFT);
			attType = new Combo(attDescr,SWT.NULL);
			nameText = new Text(attDescr,SWT.BORDER);
			attName = new Label(attDescr,SWT.NULL);
			label1 = new Label(attDescr,SWT.NULL);
			valueLb = new Label(attDescr,SWT.NULL);
			VarName = new Text(attDescr,SWT.BORDER);
			buttons = new Composite(dialogShell,SWT.NULL);
			CancelBtn = new Button(buttons,SWT.PUSH| SWT.CENTER);
			ApllyBtn = new Button(buttons,SWT.PUSH| SWT.CENTER);
	
			dialogShell.setText("add attribute");
			dialogShell.setSize(new org.eclipse.swt.graphics.Point(234,193));
	
			GridData attDescrLData = new GridData();
			attDescrLData.verticalAlignment = GridData.CENTER;
			attDescrLData.horizontalAlignment = GridData.BEGINNING;
			attDescrLData.widthHint = 217;
			attDescrLData.heightHint = 117;
			attDescrLData.horizontalIndent = 0;
			attDescrLData.horizontalSpan = 1;
			attDescrLData.verticalSpan = 1;
			attDescrLData.grabExcessHorizontalSpace = false;
			attDescrLData.grabExcessVerticalSpace = false;
			attDescr.setLayoutData(attDescrLData);
			attDescr.setText("Attribute Description");
			attDescr.setSize(new org.eclipse.swt.graphics.Point(217,117));
			final Font attDescrfont = new Font(Display.getDefault(),"Courier New",8,0);
			attDescr.setFont(attDescrfont);
	
			FormData variableLbLData = new FormData();
			variableLbLData.height = 20;
			variableLbLData.width = 130;
			variableLbLData.left =  new FormAttachment(11, 1000, 0);
			variableLbLData.right =  new FormAttachment(610, 1000, 0);
			variableLbLData.top =  new FormAttachment(495, 1000, 0);
			variableLbLData.bottom =  new FormAttachment(671, 1000, 0);
			variableLb.setLayoutData(variableLbLData);
			variableLb.setAlignment(SWT.RIGHT);
			variableLb.setText("Variable:");
			variableLb.setSize(new org.eclipse.swt.graphics.Point(130,21));
			final Font variableLbfont = new Font(Display.getDefault(),"Courier New",12,1);
			variableLb.setFont(variableLbfont);
	
			FormData isValueLData = new FormData();
			isValueLData.height = 20;
			isValueLData.width = 110;
			isValueLData.left =  new FormAttachment(34, 1000, 0);
			isValueLData.right =  new FormAttachment(541, 1000, 0);
			isValueLData.top =  new FormAttachment(320, 1000, 0);
			isValueLData.bottom =  new FormAttachment(495, 1000, 0);
			isValue.setLayoutData(isValueLData);
			isValue.setSelection(true);
			isValue.setText("is Value?");
			isValue.setSize(new org.eclipse.swt.graphics.Point(110,20));
			final Font isValuefont = new Font(Display.getDefault(),"Courier New",10,1);
			isValue.setFont(isValuefont);
			isValue.addSelectionListener( new SelectionAdapter() {
				public void widgetSelected(SelectionEvent evt) {
					isValueWidgetSelected(evt);
				}
			});
	
			FormData attTypeLData = new FormData();
			attTypeLData.height = 27;
			attTypeLData.width = 115;
			attTypeLData.left =  new FormAttachment(311, 1000, 0);
			attTypeLData.right =  new FormAttachment(956, 1000, 0);
			attTypeLData.top =  new FormAttachment(688, 1000, 0);
			attTypeLData.bottom =  new FormAttachment(899, 1000, 0);
			attType.setLayoutData(attTypeLData);
			attType.setSize(new org.eclipse.swt.graphics.Point(115,27));
			final Font attTypefont = new Font(Display.getDefault(),"Courier New",10,0);
			attType.setFont(attTypefont);
	
			FormData nameTextLData = new FormData();
			nameTextLData.height = 13;
			nameTextLData.width = 63;
			nameTextLData.left =  new FormAttachment(633, 1000, 0);
			nameTextLData.right =  new FormAttachment(956, 1000, 0);
			nameTextLData.top =  new FormAttachment(495, 1000, 0);
			nameTextLData.bottom =  new FormAttachment(671, 1000, 0);
			nameText.setLayoutData(nameTextLData);
			nameText.setDoubleClickEnabled(true);
			nameText.setFont(attTypefont);
			nameText.setSize(new org.eclipse.swt.graphics.Point(63,14));
	
			FormData attNameLData = new FormData();
			attNameLData.height = 21;
			attNameLData.width = 55;
			attNameLData.left =  new FormAttachment(11, 1000, 0);
			attNameLData.right =  new FormAttachment(264, 1000, 0);
			attNameLData.top =  new FormAttachment(688, 1000, 0);
			attNameLData.bottom =  new FormAttachment(864, 1000, 0);
			attName.setLayoutData(attNameLData);
			attName.setText("Type:");
			attName.setSize(new org.eclipse.swt.graphics.Point(55,21));
			attName.setFont(variableLbfont);
	
			FormData label1LData = new FormData();
			label1LData.height = 21;
			label1LData.width = 55;
			label1LData.left =  new FormAttachment(11, 1000, 0);
			label1LData.right =  new FormAttachment(264, 1000, 0);
			label1LData.top =  new FormAttachment(100, 1000, 0);
			label1LData.bottom =  new FormAttachment(276, 1000, 0);
			label1.setLayoutData(label1LData);
			label1.setText("Name:");
			label1.setSize(new org.eclipse.swt.graphics.Point(55,21));
			label1.setFont(variableLbfont);
	
			FormData valueLbLData = new FormData();
			valueLbLData.height = 20;
			valueLbLData.width = 130;
			valueLbLData.left =  new FormAttachment(11, 1000, 0);
			valueLbLData.right =  new FormAttachment(610, 1000, 0);
			valueLbLData.top =  new FormAttachment(495, 1000, 0);
			valueLbLData.bottom =  new FormAttachment(671, 1000, 0);
			valueLb.setLayoutData(valueLbLData);
			valueLb.setAlignment(SWT.RIGHT);
			valueLb.setText("Value:");
			valueLb.setSize(new org.eclipse.swt.graphics.Point(130,21));
			valueLb.setFont(variableLbfont);
	
			FormData VarNameLData = new FormData();
			VarNameLData.height = 14;
			VarNameLData.width = 133;
			VarNameLData.left =  new FormAttachment(311, 1000, 0);
			VarNameLData.right =  new FormAttachment(956, 1000, 0);
			VarNameLData.top =  new FormAttachment(100, 1000, 0);
			VarNameLData.bottom =  new FormAttachment(276, 1000, 0);
			VarName.setLayoutData(VarNameLData);
			VarName.setFont(attTypefont);
			VarName.setSize(new org.eclipse.swt.graphics.Point(133,14));
			FormLayout attDescrLayout = new FormLayout();
			attDescr.setLayout(attDescrLayout);
			attDescrLayout.marginWidth = 0;
			attDescrLayout.marginHeight = 0;
			attDescr.layout();
	
			GridData buttonsLData = new GridData();
			buttonsLData.verticalAlignment = GridData.CENTER;
			buttonsLData.horizontalAlignment = GridData.BEGINNING;
			buttonsLData.widthHint = 222;
			buttonsLData.heightHint = 51;
			buttonsLData.horizontalIndent = 0;
			buttonsLData.horizontalSpan = 1;
			buttonsLData.verticalSpan = 1;
			buttonsLData.grabExcessHorizontalSpace = false;
			buttonsLData.grabExcessVerticalSpace = false;
			buttons.setLayoutData(buttonsLData);
			buttons.setSize(new org.eclipse.swt.graphics.Point(222,51));
	
			FormData CancelBtnLData = new FormData();
			CancelBtnLData.height = 30;
			CancelBtnLData.width = 58;
			CancelBtnLData.left =  new FormAttachment(695, 1000, 0);
			CancelBtnLData.right =  new FormAttachment(957, 1000, 0);
			CancelBtnLData.top =  new FormAttachment(284, 1000, 0);
			CancelBtnLData.bottom =  new FormAttachment(872, 1000, 0);
			CancelBtn.setLayoutData(CancelBtnLData);
			CancelBtn.setText("CANCEL");
			CancelBtn.setSize(new org.eclipse.swt.graphics.Point(58,30));
			final Font CancelBtnfont = new Font(Display.getDefault(),"Courier New",8,1);
			CancelBtn.setFont(CancelBtnfont);
			CancelBtn.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					CancelBtnMouseDown(evt);
				}
			});
	
			FormData ApllyBtnLData = new FormData();
			ApllyBtnLData.height = 30;
			ApllyBtnLData.width = 60;
			ApllyBtnLData.left =  new FormAttachment(51, 1000, 0);
			ApllyBtnLData.right =  new FormAttachment(322, 1000, 0);
			ApllyBtnLData.top =  new FormAttachment(284, 1000, 0);
			ApllyBtnLData.bottom =  new FormAttachment(872, 1000, 0);
			ApllyBtn.setLayoutData(ApllyBtnLData);
			ApllyBtn.setText("APPLY");
			ApllyBtn.setSize(new org.eclipse.swt.graphics.Point(60,30));
			ApllyBtn.setFont(CancelBtnfont);
			ApllyBtn.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					ApllyBtnMouseDown(evt);
				}
			});
			FormLayout buttonsLayout = new FormLayout();
			buttons.setLayout(buttonsLayout);
			buttonsLayout.marginWidth = 0;
			buttonsLayout.marginHeight = 0;
			buttons.layout();
			GridLayout dialogShellLayout = new GridLayout(1, true);
			dialogShell.setLayout(dialogShellLayout);
			dialogShellLayout.marginWidth = 5;
			dialogShellLayout.marginHeight = 5;
			dialogShellLayout.numColumns = 1;
			dialogShellLayout.makeColumnsEqualWidth = true;
			dialogShellLayout.horizontalSpacing = 5;
			dialogShellLayout.verticalSpacing = 5;
			dialogShell.layout();
			dialogShell.addDisposeListener(new DisposeListener() {
				public void widgetDisposed(DisposeEvent e) {
					attDescrfont.dispose();
					variableLbfont.dispose();
					isValuefont.dispose();
					attTypefont.dispose();
					CancelBtnfont.dispose();
				}
			});
			Rectangle bounds = dialogShell.computeTrim(0, 0, 234,193);
			dialogShell.setSize(bounds.width, bounds.height);
			postInitGUI();
			dialogShell.open();
			Display display = dialogShell.getDisplay();
			while (!dialogShell.isDisposed()) {
				if (!display.readAndDispatch())
					display.sleep();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
    /** Add your pre-init code in here         */
    public void preInitGUI(){}

    /**
     * Adds some pre defined types to the dialog,
     * centers the dialog on the screen
     */
    public void postInitGUI() {
        attType.add("String");
        attType.add("Integer");
        attType.add("Boolean");
        attType.add("Double");
        attType.add("Short");
        attType.add("Byte");

        this.setAttributeValues(name, value, type);
        isValue.setSelection(!isVariable);
        initAttribute(isVariable);

        Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
        int x = (int) dim.getWidth();
        int y = (int) dim.getHeight();
        x = (x / 2) - (dialogShell.getSize().x / 2);
        y = (y / 2) - (dialogShell.getSize().y / 2);
        dialogShell.setLocation(x, y);

        // add a name to the dialogShell
        dialogShell.setText("Change Attribute Values");

        // change the TabList
        Control[] con = { VarName, nameText, attType };
        attDescr.setTabList(con);

        Control[] con2 = { ApllyBtn, CancelBtn };
        buttons.setTabList(con2);
    }

    private void initAttribute(boolean b) {
        this.valueLb.setVisible(!b);
        this.variableLb.setVisible(b);
    }

	/**
	* This static method creates a new instance of this class and shows
	* it inside a new Shell.
	*
	* It is a convenience method for showing the GUI, but it can be
	* copied and used as a basis for your own code.	*
	* It is auto-generated code - the body of this method will be
	* re-generated after any changes are made to the GUI.
	* However, if you delete this method it will not be re-created.	*/
    public static void showGUI(){
		try {
			Display display = Display.getDefault();
			Shell shell = new Shell(display);
			AddAttributeDialog inst = new AddAttributeDialog(shell, SWT.NULL);
			inst.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
    /**
     * Handler for the ApplyButton
     * @param evt - the MouseEvent given when clicking on
     * the applyButton
     */
    protected void ApllyBtnMouseDown(MouseEvent evt) {
        name = VarName.getText();
        value = nameText.getText();
        type = attType.getText();

        if (isValidString(name, true) && isValidString(value, false)) {
            state = true;
        }
        else {
            // Show Error Dialog
            MessageBox msgb = new MessageBox(dialogShell, 0);
            msgb.setText("ERROR #100234");
            msgb.setMessage("Error in Attribute declaration!");
            msgb.open();
        }

        dialogShell.close();
    }

    /**
     * Handler for the Cancel-Button
     * @param evt - the MouseEvent
     */
    protected void CancelBtnMouseDown(MouseEvent evt) {
        dialogShell.close();
    }

    /**
     * Methods for retrieving the Values
     * from the Text-Fields/Combo-Box
     */
    public String getAttributeName() {
        return name;
    }

    /**
     * Retrieves teh Attributes value
     * @return - the value
     */
    public String getAttributeValue() {
        return value;
    }

    /**
     * Retrieves the attributes type
     * @return - the type
     */
    public String getAttributeType() {
        return type;
    }

    /**
     * @return - if apply is selected
     */
    public boolean isState() {
        return state;
    }

    /**
     * This method is for adding Values into the
     * Textfields, used for edititng an attribute
     * @param name - String value of the name
     * @param value - String value of the value
     * @param type - String value of the type
     */
    public void setAttributeValues(String name, String value, String type) {
        this.name = name;
        VarName.setText(name);
        this.value = value;
        nameText.setText(value);
        this.type = type;
        attType.setText(type);
    }

    /**
     * This method checks if the String given is not null,
     * not "", consists of no Space-Characters and looks fine overall:
     * for name=true, there are only normal characters allowed
     **/
    private boolean isValidString(String str, boolean name) {
        if (str == null)
            return false;

        if (str.length() == 0)
            return false;

        if (name) {
            if (str.indexOf(" ") >= 0)
                return false;
        }

        return true;
    }

    /**
     * Updates the GUI when isValue is selected
     * @param evt
     */
    protected void isValueWidgetSelected(SelectionEvent evt) {
        if (isValue.getSelection()) {
            initAttribute(false);
            setIsVariable(false);
        }
        else {
            initAttribute(true);
            setIsVariable(true);
        }
    }

    /**
     * Checks, if isVariable is selected
     * @return - true, if "isVariable" is checked
     */
    public boolean isVariable() {
        return isVariable;
    }

    /**
     * Sets the isVariable flag to the given value
     * @param b - boolean falg
     */
    public void setIsVariable(boolean b) {
        this.isVariable = b;
    }
}
