/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.dialogs;


import java.awt.Dimension;
import java.awt.Toolkit;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.LinkedList;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import vocleditor.editors.VOCLEditorConstants;
import vocleditor.model.AttributeElement;
import vocleditor.model.VarDecElement;



/**
* This code was generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a
* for-profit company or business) then you should purchase
* a license - please visit www.cloudgarden.com for details.
*/
public class ClassifierPropertyDialog extends org.eclipse.swt.widgets.Dialog {
	private Label label1;
	private Text nameOfMtxt;
	private Label nameOfM;
	private Combo typeRC;
	private Label typeR;
	private Text returnVar;
	private Label RVarLb;
	private Label Txt;
	private Label image;
	private Button removeP;
	private Button editP;
	private Button addP;
	private List parameterList;
	private Button addMethod;
	private Group Method;
	private Button removeAttribute;
	private Button addAtribute;
	private Button editAttribute;
	private List attributeList;
	private Group attGroup;
	private Composite compositeAM;
	private Button apply;
	private Composite buttons;
	private Text varText;
	private Label varLabel;
	private Composite varName;
	
	private Shell dialogShell;

	private Hashtable values=new Hashtable();


	/**
	 * Constructor Chain for this Dialog
	 * name is the name of the Class and therefore not
	 * editable. It appears in the Frame-Head
	 */
	public ClassifierPropertyDialog(Shell parent, int style) {
		super(parent, style);
	}
	
	/**
	 * Constructor Chain for this Dialog
	 * name is the name of the Class and therefore not
	 * editable. It appears in the Frame-Head
	 */
	public ClassifierPropertyDialog(Shell parent,String name,String type) {
		super(parent);
	}	
	/**
	* Opens the Dialog Shell.
	* Auto-generated code - any changes you make will disappear.
	*/
	public void open(){
		try {
			preInitGUI();
	
			Shell parent = getParent();
			dialogShell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
			dialogShell.setText(getText());
			varName = new Composite(dialogShell,SWT.NULL);
			varText = new Text(varName,SWT.BORDER);
			varLabel = new Label(varName,SWT.NULL);
			image = new Label(varName,SWT.NULL);
			Txt = new Label(varName,SWT.NULL);
			label1 = new Label(varName,SWT.NULL);
			compositeAM = new Composite(dialogShell,SWT.NULL);
			attGroup = new Group(compositeAM,SWT.NULL);
			attributeList = new List(attGroup,SWT.BORDER);
			editAttribute = new Button(attGroup,SWT.PUSH| SWT.CENTER);
			addAtribute = new Button(attGroup,SWT.PUSH| SWT.CENTER);
			removeAttribute = new Button(attGroup,SWT.PUSH| SWT.CENTER);
			Method = new Group(compositeAM,SWT.NO_RADIO_GROUP);
			nameOfMtxt = new Text(Method,SWT.BORDER);
			nameOfM = new Label(Method,SWT.NULL);
			typeRC = new Combo(Method,SWT.BORDER);
			typeR = new Label(Method,SWT.NULL);
			returnVar = new Text(Method,SWT.BORDER);
			RVarLb = new Label(Method,SWT.NULL);
			removeP = new Button(Method,SWT.PUSH| SWT.CENTER);
			editP = new Button(Method,SWT.PUSH| SWT.CENTER);
			addP = new Button(Method,SWT.PUSH| SWT.CENTER);
			parameterList = new List(Method,SWT.BORDER);
			addMethod = new Button(Method,SWT.RADIO| SWT.LEFT);
			buttons = new Composite(dialogShell,SWT.NULL);
			apply = new Button(buttons,SWT.PUSH| SWT.CENTER);
	
			dialogShell.setText("ClassifierRole Properties");
			dialogShell.setSize(new org.eclipse.swt.graphics.Point(600,425));
	
			GridData varNameLData = new GridData();
			varNameLData.verticalAlignment = GridData.CENTER;
			varNameLData.horizontalAlignment = GridData.BEGINNING;
			varNameLData.widthHint = 583;
			varNameLData.heightHint = 60;
			varNameLData.horizontalIndent = 0;
			varNameLData.horizontalSpan = 1;
			varNameLData.verticalSpan = 1;
			varNameLData.grabExcessHorizontalSpace = false;
			varNameLData.grabExcessVerticalSpace = false;
			varName.setLayoutData(varNameLData);
			varName.setSize(new org.eclipse.swt.graphics.Point(583,60));
			final Color varNamebackground = new Color(Display.getDefault(),255,255,255);
			varName.setBackground(varNamebackground);
			final Font varNamefont = new Font(Display.getDefault(),"Courier New",8,0);
			varName.setFont(varNamefont);
	
			varText.setTabs(1);
			final Font varTextfont = new Font(Display.getDefault(),"Courier New",12,0);
			varText.setFont(varTextfont);
			varText.setSize(new org.eclipse.swt.graphics.Point(138,14));
			varText.setBounds(new org.eclipse.swt.graphics.Rectangle(319,32,145,21));
	
			varLabel.setText("Variable Name:");
			varLabel.setSize(new org.eclipse.swt.graphics.Point(145,22));
			varLabel.setBackground(varNamebackground);
			varLabel.setBounds(new org.eclipse.swt.graphics.Rectangle(171,34,145,22));
			final Font varLabelfont = new Font(Display.getDefault(),"Courier New",12,1);
			varLabel.setFont(varLabelfont);
	
			final org.eclipse.swt.graphics.Image imageimage = new org.eclipse.swt.graphics.Image(Display.getDefault(), getClass().getClassLoader().getResourceAsStream("vocleditor/dialogs/fig/newclass_wiz.gif"));
			imageimage.setBackground(image.getBackground());
			image.setImage(imageimage);
			image.setSize(new org.eclipse.swt.graphics.Point(76,60));
			image.setBounds(new org.eclipse.swt.graphics.Rectangle(503,0,76,60));
	
			Txt.setText("Properties");
			Txt.setSize(new org.eclipse.swt.graphics.Point(145,21));
			Txt.setBackground(varNamebackground);
			Txt.setBounds(new org.eclipse.swt.graphics.Rectangle(73,7,145,21));
			Txt.setFont(varLabelfont);
	
			label1.setText("label1");
			final org.eclipse.swt.graphics.Image label1image = new org.eclipse.swt.graphics.Image(Display.getDefault(), getClass().getClassLoader().getResourceAsStream("vocleditor/dialogs/fig/newEEnum_wizR.GIF"));
			label1image.setBackground(label1.getBackground());
			label1.setImage(label1image);
			label1.setSize(new org.eclipse.swt.graphics.Point(60,47));
			label1.setBounds(new org.eclipse.swt.graphics.Rectangle(4,5,60,47));
			varName.setLayout(null);
	
			GridData compositeAMLData = new GridData();
			compositeAMLData.verticalAlignment = GridData.CENTER;
			compositeAMLData.horizontalAlignment = GridData.BEGINNING;
			compositeAMLData.widthHint = 590;
			compositeAMLData.heightHint = 300;
			compositeAMLData.horizontalIndent = 0;
			compositeAMLData.horizontalSpan = 1;
			compositeAMLData.verticalSpan = 1;
			compositeAMLData.grabExcessHorizontalSpace = false;
			compositeAMLData.grabExcessVerticalSpace = false;
			compositeAM.setLayoutData(compositeAMLData);
			compositeAM.setSize(new org.eclipse.swt.graphics.Point(590,300));
	
			GridData attGroupLData = new GridData();
			attGroupLData.verticalAlignment = GridData.CENTER;
			attGroupLData.horizontalAlignment = GridData.BEGINNING;
			attGroupLData.widthHint = 284;
			attGroupLData.heightHint = 274;
			attGroupLData.horizontalIndent = 0;
			attGroupLData.horizontalSpan = 1;
			attGroupLData.verticalSpan = 1;
			attGroupLData.grabExcessHorizontalSpace = false;
			attGroupLData.grabExcessVerticalSpace = false;
			attGroup.setLayoutData(attGroupLData);
			attGroup.setText("Attributes");
			attGroup.setSize(new org.eclipse.swt.graphics.Point(284,274));
			attGroup.setFont(varNamefont);
	
			FormData attributeListLData = new FormData();
			attributeListLData.height = 222;
			attributeListLData.width = 263;
			attributeListLData.left =  new FormAttachment(26, 1000, 0);
			attributeListLData.right =  new FormAttachment(977, 1000, 0);
			attributeListLData.top =  new FormAttachment(31, 1000, 0);
			attributeListLData.bottom =  new FormAttachment(858, 1000, 0);
			attributeList.setLayoutData(attributeListLData);
			final Font attributeListfont = new Font(Display.getDefault(),"Courier New",10,0);
			attributeList.setFont(attributeListfont);
			attributeList.setSize(new org.eclipse.swt.graphics.Point(263,223));
			attributeList.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					attributeListMouseDown(evt);
				}
			});
	
			FormData editAttributeLData = new FormData();
			editAttributeLData.height = 26;
			editAttributeLData.width = 55;
			editAttributeLData.left =  new FormAttachment(378, 1000, 0);
			editAttributeLData.right =  new FormAttachment(572, 1000, 0);
			editAttributeLData.top =  new FormAttachment(872, 1000, 0);
			editAttributeLData.bottom =  new FormAttachment(968, 1000, 0);
			editAttribute.setLayoutData(editAttributeLData);
			editAttribute.setText("EDIT");
			editAttribute.setSize(new org.eclipse.swt.graphics.Point(55,27));
			editAttribute.setEnabled(false);
			final Font editAttributefont = new Font(Display.getDefault(),"Courier New",10,1);
			editAttribute.setFont(editAttributefont);
			editAttribute.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					editAttributeMouseDown(evt);
				}
			});
	
			FormData addAtributeLData = new FormData();
			addAtributeLData.height = 26;
			addAtributeLData.width = 55;
			addAtributeLData.left =  new FormAttachment(26, 1000, 0);
			addAtributeLData.right =  new FormAttachment(220, 1000, 0);
			addAtributeLData.top =  new FormAttachment(872, 1000, 0);
			addAtributeLData.bottom =  new FormAttachment(968, 1000, 0);
			addAtribute.setLayoutData(addAtributeLData);
			addAtribute.setText("ADD");
			addAtribute.setSize(new org.eclipse.swt.graphics.Point(55,27));
			addAtribute.setFont(editAttributefont);
			addAtribute.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					addAtributeMouseDown(evt);
				}
			});
	
			FormData removeAttributeLData = new FormData();
			removeAttributeLData.height = 26;
			removeAttributeLData.width = 55;
			removeAttributeLData.left =  new FormAttachment(783, 1000, 0);
			removeAttributeLData.right =  new FormAttachment(977, 1000, 0);
			removeAttributeLData.top =  new FormAttachment(872, 1000, 0);
			removeAttributeLData.bottom =  new FormAttachment(968, 1000, 0);
			removeAttribute.setLayoutData(removeAttributeLData);
			removeAttribute.setText("REMOVE");
			removeAttribute.setSize(new org.eclipse.swt.graphics.Point(55,27));
			removeAttribute.setEnabled(false);
			removeAttribute.setFont(editAttributefont);
			removeAttribute.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					removeAttributeMouseDown(evt);
				}
			});
			FormLayout attGroupLayout = new FormLayout();
			attGroup.setLayout(attGroupLayout);
			attGroupLayout.marginWidth = 0;
			attGroupLayout.marginHeight = 0;
			attGroup.layout();
	
			GridData MethodLData = new GridData();
			MethodLData.verticalAlignment = GridData.CENTER;
			MethodLData.horizontalAlignment = GridData.BEGINNING;
			MethodLData.widthHint = 284;
			MethodLData.heightHint = 274;
			MethodLData.horizontalIndent = 0;
			MethodLData.horizontalSpan = 1;
			MethodLData.verticalSpan = 1;
			MethodLData.grabExcessHorizontalSpace = false;
			MethodLData.grabExcessVerticalSpace = false;
			Method.setLayoutData(MethodLData);
			Method.setText("Method");
			Method.setSize(new org.eclipse.swt.graphics.Point(284,274));
			Method.setFont(varNamefont);
	
			FormData nameOfMtxtLData = new FormData();
			nameOfMtxtLData.height = 13;
			nameOfMtxtLData.width = 113;
			nameOfMtxtLData.left =  new FormAttachment(466, 1000, 0);
			nameOfMtxtLData.right =  new FormAttachment(889, 1000, 0);
			nameOfMtxtLData.top =  new FormAttachment(9, 1000, 0);
			nameOfMtxtLData.bottom =  new FormAttachment(82, 1000, 0);
			nameOfMtxt.setLayoutData(nameOfMtxtLData);
			nameOfMtxt.setFont(attributeListfont);
			nameOfMtxt.setSize(new org.eclipse.swt.graphics.Point(113,13));
	
			FormData nameOfMLData = new FormData();
			nameOfMLData.height = 20;
			nameOfMLData.width = 40;
			nameOfMLData.left =  new FormAttachment(272, 1000, 0);
			nameOfMLData.right =  new FormAttachment(413, 1000, 0);
			nameOfMLData.top =  new FormAttachment(12, 1000, 0);
			nameOfMLData.bottom =  new FormAttachment(85, 1000, 0);
			nameOfM.setLayoutData(nameOfMLData);
			nameOfM.setText("name");
			nameOfM.setSize(new org.eclipse.swt.graphics.Point(40,20));
			nameOfM.setFont(editAttributefont);
	
			FormData typeRCLData = new FormData();
			typeRCLData.height = 27;
			typeRCLData.width = 95;
			typeRCLData.left =  new FormAttachment(466, 1000, 0);
			typeRCLData.right =  new FormAttachment(889, 1000, 0);
			typeRCLData.top =  new FormAttachment(173, 1000, 0);
			typeRCLData.bottom =  new FormAttachment(264, 1000, 0);
			typeRC.setLayoutData(typeRCLData);
			typeRC.setSize(new org.eclipse.swt.graphics.Point(95,27));
			typeRC.setFont(attributeListfont);
	
			FormData typeRLData = new FormData();
			typeRLData.height = 20;
			typeRLData.width = 120;
			typeRLData.left =  new FormAttachment(8, 1000, 0);
			typeRLData.right =  new FormAttachment(431, 1000, 0);
			typeRLData.top =  new FormAttachment(184, 1000, 0);
			typeRLData.bottom =  new FormAttachment(257, 1000, 0);
			typeR.setLayoutData(typeRLData);
			typeR.setText("type of return");
			typeR.setSize(new org.eclipse.swt.graphics.Point(120,20));
			typeR.setFont(editAttributefont);
	
			FormData returnVarLData = new FormData();
			returnVarLData.height = 13;
			returnVarLData.width = 113;
			returnVarLData.left =  new FormAttachment(466, 1000, 0);
			returnVarLData.right =  new FormAttachment(889, 1000, 0);
			returnVarLData.top =  new FormAttachment(82, 1000, 0);
			returnVarLData.bottom =  new FormAttachment(155, 1000, 0);
			returnVar.setLayoutData(returnVarLData);
			returnVar.setFont(attributeListfont);
			returnVar.setSize(new org.eclipse.swt.graphics.Point(113,13));
	
			FormData RVarLbLData = new FormData();
			RVarLbLData.height = 20;
			RVarLbLData.width = 120;
			RVarLbLData.left =  new FormAttachment(8, 1000, 0);
			RVarLbLData.right =  new FormAttachment(431, 1000, 0);
			RVarLbLData.top =  new FormAttachment(82, 1000, 0);
			RVarLbLData.bottom =  new FormAttachment(155, 1000, 0);
			RVarLb.setLayoutData(RVarLbLData);
			RVarLb.setText("name for return");
			RVarLb.setSize(new org.eclipse.swt.graphics.Point(120,20));
			RVarLb.setFont(editAttributefont);
	
			FormData removePLData = new FormData();
			removePLData.height = 26;
			removePLData.width = 55;
			removePLData.left =  new FormAttachment(783, 1000, 0);
			removePLData.right =  new FormAttachment(977, 1000, 0);
			removePLData.top =  new FormAttachment(873, 1000, 0);
			removePLData.bottom =  new FormAttachment(968, 1000, 0);
			removeP.setLayoutData(removePLData);
			removeP.setText("REMOVE");
			removeP.setSize(new org.eclipse.swt.graphics.Point(55,26));
			removeP.setEnabled(false);
			removeP.setFont(editAttributefont);
			removeP.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					removePMouseDown(evt);
				}
			});
	
			FormData editPLData = new FormData();
			editPLData.height = 26;
			editPLData.width = 55;
			editPLData.left =  new FormAttachment(378, 1000, 0);
			editPLData.right =  new FormAttachment(572, 1000, 0);
			editPLData.top =  new FormAttachment(873, 1000, 0);
			editPLData.bottom =  new FormAttachment(968, 1000, 0);
			editP.setLayoutData(editPLData);
			editP.setText("EDIT");
			editP.setSize(new org.eclipse.swt.graphics.Point(55,26));
			editP.setEnabled(false);
			editP.setFont(editAttributefont);
			editP.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					editPMouseDown(evt);
				}
			});
	
			FormData addPLData = new FormData();
			addPLData.height = 26;
			addPLData.width = 55;
			addPLData.left =  new FormAttachment(26, 1000, 0);
			addPLData.right =  new FormAttachment(220, 1000, 0);
			addPLData.top =  new FormAttachment(873, 1000, 0);
			addPLData.bottom =  new FormAttachment(968, 1000, 0);
			addP.setLayoutData(addPLData);
			addP.setText("ADD");
			addP.setSize(new org.eclipse.swt.graphics.Point(55,26));
			addP.setFont(editAttributefont);
			addP.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					addPMouseDown(evt);
				}
			});
	
			FormData parameterListLData = new FormData();
			parameterListLData.height = 155;
			parameterListLData.width = 263;
			parameterListLData.left =  new FormAttachment(26, 1000, 0);
			parameterListLData.right =  new FormAttachment(977, 1000, 0);
			parameterListLData.top =  new FormAttachment(275, 1000, 0);
			parameterListLData.bottom =  new FormAttachment(859, 1000, 0);
			parameterList.setLayoutData(parameterListLData);
			parameterList.setFont(attributeListfont);
			parameterList.setSize(new org.eclipse.swt.graphics.Point(263,156));
	
			FormData addMethodLData = new FormData();
			addMethodLData.height = 20;
			addMethodLData.width = 80;
			addMethodLData.left =  new FormAttachment(8, 1000, 0);
			addMethodLData.right =  new FormAttachment(290, 1000, 0);
			addMethodLData.top =  new FormAttachment(9, 1000, 0);
			addMethodLData.bottom =  new FormAttachment(82, 1000, 0);
			addMethod.setLayoutData(addMethodLData);
			addMethod.setText("Method");
			addMethod.setSize(new org.eclipse.swt.graphics.Point(80,20));
			addMethod.setFont(editAttributefont);
			addMethod.addSelectionListener( new SelectionAdapter() {
				public void widgetSelected(SelectionEvent evt) {
					addMethodWidgetSelected(evt);
				}
			});
			FormLayout MethodLayout = new FormLayout();
			Method.setLayout(MethodLayout);
			MethodLayout.marginWidth = 0;
			MethodLayout.marginHeight = 0;
			Method.layout();
			GridLayout compositeAMLayout = new GridLayout(2, true);
			compositeAM.setLayout(compositeAMLayout);
			compositeAMLayout.marginWidth = 5;
			compositeAMLayout.marginHeight = 5;
			compositeAMLayout.numColumns = 2;
			compositeAMLayout.makeColumnsEqualWidth = true;
			compositeAMLayout.horizontalSpacing = 5;
			compositeAMLayout.verticalSpacing = 5;
			compositeAM.layout();
	
			GridData buttonsLData = new GridData();
			buttonsLData.verticalAlignment = GridData.CENTER;
			buttonsLData.horizontalAlignment = GridData.BEGINNING;
			buttonsLData.widthHint = 587;
			buttonsLData.heightHint = 43;
			buttonsLData.horizontalIndent = 0;
			buttonsLData.horizontalSpan = 1;
			buttonsLData.verticalSpan = 1;
			buttonsLData.grabExcessHorizontalSpace = false;
			buttonsLData.grabExcessVerticalSpace = false;
			buttons.setLayoutData(buttonsLData);
			buttons.setSize(new org.eclipse.swt.graphics.Point(587,43));
	
			FormData applyLData = new FormData();
			applyLData.height = 25;
			applyLData.width = 144;
			applyLData.left =  new FormAttachment(731, 1000, 0);
			applyLData.right =  new FormAttachment(977, 1000, 0);
			applyLData.top =  new FormAttachment(197, 1000, 0);
			applyLData.bottom =  new FormAttachment(779, 1000, 0);
			apply.setLayoutData(applyLData);
			apply.setText("CLOSE");
			apply.setSize(new org.eclipse.swt.graphics.Point(144,25));
			apply.setFont(editAttributefont);
			apply.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					applyMouseDown(evt);
				}
			});
			FormLayout buttonsLayout = new FormLayout();
			buttons.setLayout(buttonsLayout);
			buttonsLayout.marginWidth = 0;
			buttonsLayout.marginHeight = 0;
			buttons.layout();
			GridLayout dialogShellLayout = new GridLayout(1, true);
			dialogShell.setLayout(dialogShellLayout);
			dialogShellLayout.marginWidth = 5;
			dialogShellLayout.marginHeight = 5;
			dialogShellLayout.numColumns = 1;
			dialogShellLayout.makeColumnsEqualWidth = true;
			dialogShellLayout.horizontalSpacing = 5;
			dialogShellLayout.verticalSpacing = 5;
			dialogShell.layout();
			dialogShell.addDisposeListener(new DisposeListener() {
				public void widgetDisposed(DisposeEvent e) {
					varNamebackground.dispose();
					varNamefont.dispose();
					varTextfont.dispose();
					varLabelfont.dispose();
					imageimage.dispose();
					label1image.dispose();
					attributeListfont.dispose();
					editAttributefont.dispose();
				}
			});
			Rectangle bounds = dialogShell.computeTrim(0, 0, 600,425);
			dialogShell.setSize(bounds.width, bounds.height);
			postInitGUI();
			dialogShell.open();
			Display display = dialogShell.getDisplay();
			while (!dialogShell.isDisposed()) {
				if (!display.readAndDispatch())
					display.sleep();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/** Add your pre-init code in here 	*/
	public void preInitGUI(){
	}

	/** Add your post-init code in here 	*/
	public void postInitGUI(){
		this.setValues();
		Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
		int x = (int)dim.getWidth();
		int y = (int)dim.getHeight();
		x = x/2 - (dialogShell.getSize().x/2);
		y = y/2 - (dialogShell.getSize().y/2);
		dialogShell.setLocation(x,y);
	}
	
	private void initMethod(boolean s){
		this.addP.setVisible(s);
		this.editP.setVisible(s);
		this.removeP.setVisible(s);
		this.parameterList.setVisible(s);
		this.typeR.setVisible(s);
		this.typeRC.setVisible(s);
		this.RVarLb.setVisible(s);
		this.returnVar.setVisible(s);	
		this.nameOfM.setVisible(s);
		this.nameOfMtxt.setVisible(s);
	}
	
	/**
	* This static method creates a new instance of this class and shows
	* it inside a new Shell.
	*
	* It is a convenience method for showing the GUI, but it can be
	* copied and used as a basis for your own code.	*
	* It is auto-generated code - the body of this method will be
	* re-generated after any changes are made to the GUI.
	* However, if you delete this method it will not be re-created.	*/
	public static void showGUI(){
		try {
			Display display = Display.getDefault();
			Shell shell = new Shell(display);
			ClassifierPropertyDialog inst = new ClassifierPropertyDialog(shell, SWT.NULL);
			inst.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/**
	 * This method sets the Values to the Dialog by reading them form
	 * the ClassifierRole and inserting to the Dialogs elements.
	 * @param clr - the ClassifierRole which properties to show
	 */
	public void setValues() {	
		dialogShell.setText("ClassifierRole Properties: " + 
							(String)(values.get(VOCLEditorConstants.CLASS_NAME)));
												
		varText.setText((String)(values.get(VOCLEditorConstants.CLASS_VAR_NAME)));
		
		java.util.List attlist=new LinkedList();
		attlist.addAll((java.util.List) values.get(VOCLEditorConstants.ATTRIBUTES));
		// add all Attributes
		Iterator it=attlist.iterator();
		while( it.hasNext()) {
			AttributeElement attElem = (AttributeElement)it.next();
			String aName = attElem.getAttName();
			String aValue=attElem.getValue();
			if(attElem.isVar()) aValue=attElem.getVarname();
			String aType = attElem.getType();		
			attributeList.add(aName + ": " + "\"" + aValue + "\"" + "  [" + aType+"]");
		}
		if(values.get(VOCLEditorConstants.METHOD_NAME)==null){
			initMethod(false);
			return;
		}
		nameOfMtxt.setText((String) values.get(VOCLEditorConstants.METHOD_NAME));
		typeRC.setText((String) values.get(VOCLEditorConstants.METHOD_TYPE));
		if(values.get(VOCLEditorConstants.METHOD_RETURN_NAME)!=null)
			returnVar.setText((String) values.get(VOCLEditorConstants.METHOD_RETURN_NAME));
			
		//add Method with all Parameters
		java.util.List parlist=new LinkedList();
		parlist.addAll((java.util.List) values.get(VOCLEditorConstants.METHOD_PARAMETER));
		it=parlist.iterator();
		while( it.hasNext()){
			VarDecElement param = (VarDecElement) it.next();
			String pName = param.getVarname();
			String pType = param.getType();
			parameterList.add(pName +  " [" + pType + "]");
		}	
		if(parameterList.getItemCount()>0){
			editP.setEnabled(true);
			removeP.setEnabled(true);
		}
		initMethod(true);	
		addMethod.setSelection(true);
	}


	/** Auto-generated event handler method */
	protected void addAtributeMouseDown(MouseEvent evt){
		AddAttributeDialog aad = new AddAttributeDialog(dialogShell,0);
		aad.open();
		// check if the apply-button was clicked
		if (!aad.isState()) return;
		
		String attValue = aad.getAttributeValue();
		String attName  = aad.getAttributeName();
		String attType  = aad.getAttributeType();
	
		AttributeElement attElem=new AttributeElement();
		attElem.setAttName(attName);attElem.setType(attType);
		attElem.setValue(attValue);attElem.setVar(aad.isVariable());
		//add Variable
		if(attElem.isVar()){
			attElem.setVarname(attValue);
		}
		java.util.List attlist=new LinkedList();
		attlist.addAll((java.util.List) values.get(VOCLEditorConstants.ATTRIBUTES));
		attlist.add(attElem);
		values.put(VOCLEditorConstants.ATTRIBUTES,attlist);		
		// apdate the List
		addAttributeToList(attName,attType,attValue);			
	}
	
	
	/**
	 * This method adds an Attribute to the list, 
	 * specified by name, type and value.
	 * Inserted as Label in the following format:
	 * <name>: "<value>" [<type>]
	 * @param name	- the attributes name
	 * @param type	- the attributes type (e.g. String)
	 * @param value	- the attributes value
	 */
	public void addAttributeToList(String name, String type, String value) {
		String attString = new String(name + ": \"" + value + "\" [" + type + "]");
		attributeList.add(attString);
	}
	

	


	/**
	 * Checks weather the edit and remove buttons
	 * are appliabe.
	 */
	public void updateEnabledButtons() {
		if (attributeList.getSelectionIndex() > -1) {
			removeAttribute.setEnabled(true);
			editAttribute.setEnabled(true);
		} else {
			removeAttribute.setEnabled(false);
			editAttribute.setEnabled(false);
		}
	}

	/**
	 * A Listentry might be selected
	 */
	protected void attributeListMouseDown(MouseEvent evt){
		updateEnabledButtons();		
	}
	
	

	/** Auto-generated event handler method */
	protected void removeAttributeMouseDown(MouseEvent evt){
		if(attributeList.getSelectionIndex()== -1)return;
		int index=attributeList.getSelectionIndex();
		attributeList.remove(index);
		java.util.List attlist=new LinkedList();
		attlist.addAll((java.util.List) values.get(VOCLEditorConstants.ATTRIBUTES));
		attlist.remove(index);	
		values.put(VOCLEditorConstants.ATTRIBUTES,attlist);
		this.updateEnabledButtons();
	}
	
	/** Auto-generated event handler method */
	protected void applyMouseDown(MouseEvent evt){
		if(addMethod.getSelection() && nameOfMtxt.getText().trim().length()==0){
		// Show Error Dialog
			MessageBox msgb = new MessageBox(dialogShell,0);
			msgb.setText("Warning!");
			msgb.setMessage("Error in Method declaration,name is empty");
			msgb.open();
			return;
		}
		String mname=nameOfMtxt.getText();
		String rtype=typeRC.getText();
		String rvar=returnVar.getText();
		String clname=varText.getText();
		values.put(VOCLEditorConstants.CLASS_VAR_NAME,clname);
		if(addMethod.getSelection()){
			values.put(VOCLEditorConstants.METHOD_NAME,mname);
			values.put(VOCLEditorConstants.METHOD_TYPE,rtype);	
			values.put(VOCLEditorConstants.METHOD_RETURN_NAME,rvar);	
		}else{
			values.remove(VOCLEditorConstants.METHOD_NAME);
		}
		dialogShell.close();
	}


	/** Auto-generated event handler method */
	protected void editAttributeMouseDown(MouseEvent evt){	
		if(attributeList.getSelectionIndex()== -1)return;	
		int index = attributeList.getSelectionIndex();
		java.util.List attlist=new LinkedList();
		attlist.addAll((java.util.List) values.get(VOCLEditorConstants.ATTRIBUTES));
		AttributeElement attElem=(AttributeElement)attlist.get(index);
		AddAttributeDialog aad = new AddAttributeDialog(dialogShell,0,attElem);
		aad.open();
			
		// check if the apply-button was clicked
		if (!aad.isState())return;
		
		String attName  = aad.getAttributeName();
		String attValue = aad.getAttributeValue();
		String attType  = aad.getAttributeType();
		attElem.setAttName(attName);attElem.setType(attType);
		attElem.setValue(attValue);attElem.setVar(aad.isVariable());
		if(attElem.isVar())
			attElem.setVarname(attValue);
				
		attlist.set(index,attElem);
		values.put(VOCLEditorConstants.ATTRIBUTES,attlist);
		//adaptate the List
		changeAttributeOfList(index,attName,attType,attValue);
		this.updateEnabledButtons();	
	}
	
	
	/**
 	* This method adds an Attribute to the list, 
 	* specified by name, type and value.
 	* Inserted as Label in the following format:
 	* <name>: "<value>" [<type>]
 	* @param name	- the attributes name
 	* @param type	- the attributes type (e.g. String)
 	* @param value	- the attributes value
 	*/
	public void changeAttributeOfList(int index, String name, String type, String value) {
		String attString = new String(name + ": \"" + value + "\" [" + type + "]");
		String[] sel = attributeList.getItems();
		sel[index] = attString;
		attributeList.removeAll();
		for (int i = 0; i < sel.length; i++) {
			attributeList.add(sel[i]);
		}
	}

	/** Auto-generated event handler method */
	protected void addMethodWidgetSelected(SelectionEvent evt){
		if(addMethod.getSelection()){
			initMethod(true);
		}
		else{
			initMethod(false);
		}
	}

	/** Auto-generated event handler method */
	protected void addPMouseDown(MouseEvent evt){
		AddPartameterContextDialog aad = new AddPartameterContextDialog(dialogShell);
		aad.open();	
		// check if the apply-button was clicked
		if (!aad.isState())return;
		String paramName  = aad.getParameterName();
		String paramType  = aad.getParameterType();
		VarDecElement varElem=new VarDecElement(paramType,paramName);
		addParameterToList(paramName,paramType);
		java.util.List parlist=new LinkedList();	
		parlist.addAll((java.util.List) values.get(VOCLEditorConstants.METHOD_PARAMETER));
		parlist.add(varElem);
		values.put(VOCLEditorConstants.METHOD_PARAMETER,parlist);
		if(parameterList.getItemCount()>0){
				editP.setEnabled(true);
				removeP.setEnabled(true);
		}
	}

	/**
	 * This method adds an Parameter to the list, 
	 * specified by name, type and value.
	 * Inserted as Label in the following format:
	 * <name>: "<value>" [<type>]
	 * @param name	- the parameter name
	 * @param type	- the parameter type (e.g. String)
	 */
	public void addParameterToList(String name, String type) {
		String attString = new String( name +  " [" + type + "]");
		parameterList.add(attString);
	}

	/** Auto-generated event handler method */
	protected void editPMouseDown(MouseEvent evt){
		if(parameterList.getSelectionIndex()== -1)return;
		int index=parameterList.getSelectionIndex();
		
		java.util.List parlist=new LinkedList();
		parlist.addAll((java.util.List) values.get(VOCLEditorConstants.METHOD_PARAMETER));	
			
		VarDecElement varElem=(VarDecElement) parlist.get(index);
		AddPartameterContextDialog aad = new AddPartameterContextDialog(dialogShell,
											varElem.getVarname(),varElem.getType());
		aad.open();
		
		// check if the apply-button was clicked
		if (!aad.isState())return;
		String paramName  = aad.getParameterName();
		String paramType  = aad.getParameterType();

		varElem.setType(paramType);varElem.setVarname(paramName);
		parlist.set(index,varElem);
		values.put(VOCLEditorConstants.METHOD_PARAMETER,parlist);
		replaceParameterToList(index,paramName,paramType);
	}

	/**
	 * This method adds an Parameter to the list, 
	 * specified by name, type and value.
	 * Inserted as Label in the following format:
	 * <name>: "<value>" [<type>]
	 * @param name	- the parameter name
	 * @param type	- the parameter type (e.g. String)

	 */
	public void replaceParameterToList(int index,String name, String type) {	
		String parString = new String(name +  " [" + type + "]");
		String[] sel = parameterList.getItems();
		sel[index] = parString;
		parameterList.removeAll();
		for (int i = 0; i < sel.length; i++) {
			parameterList.add(sel[i]);
		}
	}	

	/** Auto-generated event handler method */
	protected void removePMouseDown(MouseEvent evt){
		if(parameterList.getSelectionIndex()== -1)return;
		int index=parameterList.getSelectionIndex();
		parameterList.remove(index);	
		java.util.List parlist=new LinkedList();
		parlist.addAll((java.util.List) values.get(VOCLEditorConstants.METHOD_PARAMETER));
		parlist.remove(index);	
		values.put(VOCLEditorConstants.METHOD_PARAMETER,parlist);
	}


	/**
	 * @return
	 */
	public Hashtable getValues() {
		return values;
	}

	/**
	 * @param hashtable
	 */
	public void setValues(Hashtable hashtable) {
		values.clear();
		values.putAll(hashtable);
	}

}