/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.dialogs;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.util.LinkedList;

import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.SWT;

/**
* This code was generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a
* for-profit company or business) then you should purchase
* a license - please visit www.cloudgarden.com for details.
*/
public class CreateMethodContextDialog extends org.eclipse.swt.widgets.Dialog {
	private Label label1;
	private Composite composite1;
	private Shell dialogShell;
	private Button apply;
	private Composite buttons;
	private Button removeParameter;
	private Button addParameter;
	private Button editParameter;
	private List parameterList;
	private Group parGroup;
	private java.util.List param=new LinkedList();
	private String Rtype;

	public CreateMethodContextDialog(Shell parent, int style) {
		super(parent, style);
	}
	
	public CreateMethodContextDialog(Shell parent) {
		super(parent);
	}
	public CreateMethodContextDialog(Shell parent,java.util.List param) {
		super(parent);
		this.param=param;		
	}
	/** Auto-generated event handler method */
	protected void editParameterMouseDown(MouseEvent evt){
		if(parameterList.getSelectionIndex()== -1)return;
		java.util.List list=(java.util.List)param.get(parameterList.getSelectionIndex());
		AddPartameterContextDialog aad = new AddPartameterContextDialog(dialogShell,(String)list.get(0),(String)list.get(1));
		aad.open();
		
		// check if the apply-button was clicked
		if (!aad.isState())return;
		String attName  = aad.getParameterName();
		String attType  = aad.getParameterType();
		replaceParameterToList(parameterList.getSelectionIndex(),attName,attType);
	}

	/** Auto-generated event handler method */
	protected void addParameterMouseDown(MouseEvent evt){
		AddPartameterContextDialog aad = new AddPartameterContextDialog(dialogShell);
		aad.open();	
		// check if the apply-button was clicked
		if (!aad.isState())return;
		String attName  = aad.getParameterName();
		String attType  = aad.getParameterType();
		java.util.List list=new LinkedList();
		list.add(attName);list.add(attType);
		addParameterToList(attName,attType);	
		param.add(list);
		if(param.size()>0){
			editParameter.setEnabled(true);
			removeParameter.setEnabled(true);
		}


	}



	/**
	 * This method adds an Attribute to the list, 
	 * specified by name, type and value.
	 * Inserted as Label in the following format:
	 * <name>: "<value>" [<type>]
	 * @param name	- the attributes name
	 * @param type	- the attributes type (e.g. String)
	 */
	public void addParameterToList(String name, String type) {
		String attString = new String( name +  " [" + type + "]");
		parameterList.add(attString);
	}
	
	/**
	 * This method adds an Attribute to the list, 
	 * specified by name, type and value.
	 * Inserted as Label in the following format:
	 * <name>: "<value>" [<type>]
	 * @param name	- the attributes name
	 * @param type	- the attributes type (e.g. String)

	 */
	public void replaceParameterToList(int index,String name, String type) {
		String attString = new String(name +  " [" + type + "]");
		
		java.util.List list=new LinkedList();
		list.add(name);list.add(type);
		param.set(index,list);
		parameterList.removeAll();
		for (int i = 0; i < param.size(); i++) {
			parameterList.add(((java.util.List)param.get(i)).get(0)+"["+((java.util.List)param.get(i)).get(1)+"]");
		}
	}	
	/** Auto-generated event handler method */
	protected void removeParameterMouseDown(MouseEvent evt){
		if(parameterList.getSelectionIndex()== -1)return;
		int index=parameterList.getSelectionIndex();
		parameterList.remove(index);
		param.remove(index);
	}

	/** Auto-generated event handler method */
	protected void applyMouseDown(MouseEvent evt){
		dialogShell.close();
	}

	/**
	* Opens the Dialog Shell.
	* Auto-generated code - any changes you make will disappear.
	*/
	public void open(){
		try {
			preInitGUI();
	
			Shell parent = getParent();
			dialogShell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
			dialogShell.setText(getText());
			composite1 = new Composite(dialogShell,SWT.NULL);
			label1 = new Label(composite1,SWT.NULL);
			parGroup = new Group(dialogShell,SWT.NULL);
			parameterList = new List(parGroup,SWT.BORDER);
			editParameter = new Button(parGroup,SWT.PUSH| SWT.CENTER);
			addParameter = new Button(parGroup,SWT.PUSH| SWT.CENTER);
			removeParameter = new Button(parGroup,SWT.PUSH| SWT.CENTER);
			buttons = new Composite(dialogShell,SWT.NULL);
			apply = new Button(buttons,SWT.PUSH| SWT.CENTER);
	
			dialogShell.setText("Method properties");
			dialogShell.setSize(new org.eclipse.swt.graphics.Point(340,259));
	
			GridData composite1LData = new GridData();
			composite1LData.widthHint = 333;
			composite1LData.heightHint = 49;
			composite1.setLayoutData(composite1LData);
			composite1.setSize(new org.eclipse.swt.graphics.Point(333,49));
			final Color composite1background = new Color(Display.getDefault(),255,255,255);
			composite1.setBackground(composite1background);
	
			FormData label1LData = new FormData();
			label1LData.height = 43;
			label1LData.width = 330;
			label1LData.left =  new FormAttachment(1, 1000, 0);
			label1LData.right =  new FormAttachment(992, 1000, 0);
			label1LData.top =  new FormAttachment(9, 1000, 0);
			label1LData.bottom =  new FormAttachment(1000, 1000, -11);
			label1.setLayoutData(label1LData);
			label1.setText("label1");
			final org.eclipse.swt.graphics.Image label1image = new org.eclipse.swt.graphics.Image(Display.getDefault(), getClass().getClassLoader().getResourceAsStream("vocleditor/dialogs/fig/workbench.gif"));
			label1image.setBackground(label1.getBackground());
			label1.setImage(label1image);
			label1.setSize(new org.eclipse.swt.graphics.Point(330,38));
			FormLayout composite1Layout = new FormLayout();
			composite1.setLayout(composite1Layout);
			composite1Layout.marginWidth = 0;
			composite1Layout.marginHeight = 0;
			composite1.layout();
	
			GridData parGroupLData = new GridData();
			parGroupLData.verticalAlignment = GridData.CENTER;
			parGroupLData.horizontalAlignment = GridData.BEGINNING;
			parGroupLData.widthHint = 321;
			parGroupLData.heightHint = 139;
			parGroupLData.horizontalIndent = 0;
			parGroupLData.horizontalSpan = 1;
			parGroupLData.verticalSpan = 1;
			parGroupLData.grabExcessHorizontalSpace = false;
			parGroupLData.grabExcessVerticalSpace = false;
			parGroup.setLayoutData(parGroupLData);
			parGroup.setText("Parameters");
			parGroup.setSize(new org.eclipse.swt.graphics.Point(321,139));
			final Font parGroupfont = new Font(Display.getDefault(),"Courier New",8,0);
			parGroup.setFont(parGroupfont);
	
			FormData parameterListLData = new FormData();
			parameterListLData.height = 89;
			parameterListLData.width = 291;
			parameterListLData.left =  new FormAttachment(23, 1000, 0);
			parameterListLData.right =  new FormAttachment(952, 1000, 0);
			parameterListLData.top =  new FormAttachment(77, 1000, 0);
			parameterListLData.bottom =  new FormAttachment(744, 1000, 0);
			parameterList.setLayoutData(parameterListLData);
			final Font parameterListfont = new Font(Display.getDefault(),"Courier New",10,0);
			parameterList.setFont(parameterListfont);
			parameterList.setSize(new org.eclipse.swt.graphics.Point(291,89));
	
			FormData editParameterLData = new FormData();
			editParameterLData.height = 25;
			editParameterLData.width = 64;
			editParameterLData.left =  new FormAttachment(397, 1000, 0);
			editParameterLData.right =  new FormAttachment(596, 1000, 0);
			editParameterLData.top =  new FormAttachment(758, 1000, 0);
			editParameterLData.bottom =  new FormAttachment(938, 1000, 0);
			editParameter.setLayoutData(editParameterLData);
			editParameter.setText("EDIT");
			editParameter.setSize(new org.eclipse.swt.graphics.Point(64,25));
			editParameter.setEnabled(false);
			final Font editParameterfont = new Font(Display.getDefault(),"Courier New",8,1);
			editParameter.setFont(editParameterfont);
			editParameter.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					editParameterMouseDown(evt);
				}
			});
	
			FormData addParameterLData = new FormData();
			addParameterLData.height = 25;
			addParameterLData.width = 63;
			addParameterLData.left =  new FormAttachment(38, 1000, 0);
			addParameterLData.right =  new FormAttachment(235, 1000, 0);
			addParameterLData.top =  new FormAttachment(758, 1000, 0);
			addParameterLData.bottom =  new FormAttachment(938, 1000, 0);
			addParameter.setLayoutData(addParameterLData);
			addParameter.setText("ADD");
			addParameter.setSize(new org.eclipse.swt.graphics.Point(63,25));
			addParameter.setFont(editParameterfont);
			addParameter.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					addParameterMouseDown(evt);
				}
			});
	
			FormData removeParameterLData = new FormData();
			removeParameterLData.height = 25;
			removeParameterLData.width = 63;
			removeParameterLData.left =  new FormAttachment(718, 1000, 0);
			removeParameterLData.right =  new FormAttachment(914, 1000, 0);
			removeParameterLData.top =  new FormAttachment(758, 1000, 0);
			removeParameterLData.bottom =  new FormAttachment(938, 1000, 0);
			removeParameter.setLayoutData(removeParameterLData);
			removeParameter.setText("REMOVE");
			removeParameter.setSize(new org.eclipse.swt.graphics.Point(63,25));
			removeParameter.setEnabled(false);
			removeParameter.setFont(editParameterfont);
			removeParameter.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					removeParameterMouseDown(evt);
				}
			});
			FormLayout parGroupLayout = new FormLayout();
			parGroup.setLayout(parGroupLayout);
			parGroupLayout.marginWidth = 0;
			parGroupLayout.marginHeight = 0;
			parGroup.layout();
	
			GridData buttonsLData = new GridData();
			buttonsLData.verticalAlignment = GridData.CENTER;
			buttonsLData.horizontalAlignment = GridData.BEGINNING;
			buttonsLData.widthHint = 326;
			buttonsLData.heightHint = 43;
			buttonsLData.horizontalIndent = 0;
			buttonsLData.horizontalSpan = 1;
			buttonsLData.verticalSpan = 1;
			buttonsLData.grabExcessHorizontalSpace = false;
			buttonsLData.grabExcessVerticalSpace = false;
			buttons.setLayoutData(buttonsLData);
			buttons.setSize(new org.eclipse.swt.graphics.Point(326,43));
	
			FormData applyLData = new FormData();
			applyLData.height = 25;
			applyLData.width = 77;
			applyLData.left =  new FormAttachment(713, 1000, 0);
			applyLData.right =  new FormAttachment(949, 1000, 0);
			applyLData.top =  new FormAttachment(151, 1000, 0);
			applyLData.bottom =  new FormAttachment(732, 1000, 0);
			apply.setLayoutData(applyLData);
			apply.setText("CLOSE");
			apply.setSize(new org.eclipse.swt.graphics.Point(77,25));
			final Font applyfont = new Font(Display.getDefault(),"Courier New",10,1);
			apply.setFont(applyfont);
			apply.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					applyMouseDown(evt);
				}
			});
			FormLayout buttonsLayout = new FormLayout();
			buttons.setLayout(buttonsLayout);
			buttonsLayout.marginWidth = 0;
			buttonsLayout.marginHeight = 0;
			buttons.layout();
			GridLayout dialogShellLayout = new GridLayout(1, true);
			dialogShell.setLayout(dialogShellLayout);
			dialogShellLayout.marginWidth = 5;
			dialogShellLayout.marginHeight = 5;
			dialogShellLayout.numColumns = 1;
			dialogShellLayout.makeColumnsEqualWidth = true;
			dialogShellLayout.horizontalSpacing = 5;
			dialogShellLayout.verticalSpacing = 5;
			dialogShell.layout();
			dialogShell.addDisposeListener(new DisposeListener() {
				public void widgetDisposed(DisposeEvent e) {
					composite1background.dispose();
					label1image.dispose();
					parGroupfont.dispose();
					parameterListfont.dispose();
					editParameterfont.dispose();
					applyfont.dispose();
				}
			});
			Rectangle bounds = dialogShell.computeTrim(0, 0, 340,259);
			dialogShell.setSize(bounds.width, bounds.height);
			postInitGUI();
			dialogShell.open();
			Display display = dialogShell.getDisplay();
			while (!dialogShell.isDisposed()) {
				if (!display.readAndDispatch())
					display.sleep();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/** Add your pre-init code in here 	*/
	public void preInitGUI(){
	}

	/** Add your post-init code in here 	*/
	public void postInitGUI(){
		java.util.List list=new LinkedList();
		parameterList.removeAll();
		for (int i = 0; i < param.size(); i++) {
			parameterList.add(((java.util.List)param.get(i)).get(0)+"["+((java.util.List)param.get(i)).get(1)+"]");
		}
		Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
		int x = (int)dim.getWidth();
		int y = (int)dim.getHeight();
		x = x/2 - (dialogShell.getSize().x/2);
		y = y/2 - (dialogShell.getSize().y/2);
		dialogShell.setLocation(x,y);
	}
	
	
	/**
	 * This method sets the Values to the Dialog by reading them form
	 * the ClassifierRole and inserting to the Dialogs elements.
	 * @param clr - the ClassifierRole which properties to show
	 */
	public void setValues() {
		
	}

	/** Auto-generated main method */
	public static void main(String[] args){
		showGUI();
	}

	/**
	* This static method creates a new instance of this class and shows
	* it inside a new Shell.
	*
	* It is a convenience method for showing the GUI, but it can be
	* copied and used as a basis for your own code.	*
	* It is auto-generated code - the body of this method will be
	* re-generated after any changes are made to the GUI.
	* However, if you delete this method it will not be re-created.	*/
	public static void showGUI(){
		try {
			Display display = Display.getDefault();
			Shell shell = new Shell(display);
			CreateMethodContextDialog inst = new CreateMethodContextDialog(shell, SWT.NULL);
			inst.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/**
	 * @return
	 */
	public java.util.List getParam() {
		return param;
	}

}
