/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.dialogs;

import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;

import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.SWT;

import vocleditor.editors.VOCLEditorConstants;
import VOCLModel.*;
import java.awt.Toolkit;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import java.awt.Dimension;

import vocleditor.model.AttributeElement;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.ModifyEvent;

import java.util.Enumeration;
import java.util.LinkedList;
import java.util.Hashtable;

/**
* This code was generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a
* for-profit company or business) then you should purchase
* a license - please visit www.cloudgarden.com for details.
*/
public class SetClassifierPropertyDialog extends org.eclipse.swt.widgets.Dialog {
	private Label imgLabel;	
	
	private Label label2;
	private Combo combo1;
	private Button sumButtom;
	private Combo sumVarCombo;
	private Label sumVarLabel;
	private Button noOperation;
	private Label label1;
	private Text setVarName;
	private Button setVariable;
	private Button notEmpty;
	private Button setEmpty;
	private Button apply;
	private Composite buttons;
	private Group Method;
	private Button removeAttribute;
	private Button addAtribute;
	private Button editAttribute;
	private List attributeList;
	private Group attGroup;
	private Composite compositeAM;
	private Label Txt;
	private Label image;
	private Label varLabel;
	private Text varText;
	private Composite varName;
	private Shell dialogShell;

	// here all changes are stored
	private Hashtable changes;
	private LinkedList attributesOfClassifierRole = new LinkedList();

	// These three fields remember the settings of the 
	// set-Operation field and the global varName
	private boolean changed 		= false;

	public SetClassifierPropertyDialog(Shell parent, int style, Hashtable chan) {
		super(parent, style);
		changes = chan;
	}
	
	public SetClassifierPropertyDialog(Shell parent, int style) {
		super(parent, style);
	}
	/**
	* Opens the Dialog Shell.
	* Auto-generated code - any changes you make will disappear.
	*/
	public void open(){
		try {
			preInitGUI();
	
			Shell parent = getParent();
			dialogShell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
			dialogShell.setText(getText());
			varName = new Composite(dialogShell,SWT.NULL);
			varText = new Text(varName,SWT.BORDER);
			varLabel = new Label(varName,SWT.NULL);
			image = new Label(varName,SWT.NULL);
			Txt = new Label(varName,SWT.NULL);
			imgLabel = new Label(varName,SWT.NULL);
			compositeAM = new Composite(dialogShell,SWT.NULL);
			attGroup = new Group(compositeAM,SWT.NULL);
			attributeList = new List(attGroup,SWT.BORDER);
			editAttribute = new Button(attGroup,SWT.PUSH| SWT.CENTER);
			addAtribute = new Button(attGroup,SWT.PUSH| SWT.CENTER);
			removeAttribute = new Button(attGroup,SWT.PUSH| SWT.CENTER);
			Method = new Group(compositeAM,SWT.NULL);
			sumButtom = new Button(Method,SWT.RADIO| SWT.LEFT);
			sumVarCombo = new Combo(Method,SWT.NULL);
			sumVarLabel = new Label(Method,SWT.NULL);
			noOperation = new Button(Method,SWT.RADIO| SWT.LEFT);
			label1 = new Label(Method,SWT.NULL);
			setVarName = new Text(Method,SWT.BORDER);
			setVariable = new Button(Method,SWT.RADIO| SWT.LEFT);
			notEmpty = new Button(Method,SWT.RADIO| SWT.LEFT);
			setEmpty = new Button(Method,SWT.RADIO| SWT.LEFT);
			combo1 = new Combo(Method,SWT.NULL);
			buttons = new Composite(dialogShell,SWT.NULL);
			apply = new Button(buttons,SWT.PUSH| SWT.CENTER);
	
			dialogShell.setText("ClassifierRole Properties");
			dialogShell.setSize(new org.eclipse.swt.graphics.Point(600,425));
	
			GridData varNameLData = new GridData();
			varNameLData.verticalAlignment = GridData.CENTER;
			varNameLData.horizontalAlignment = GridData.BEGINNING;
			varNameLData.widthHint = 583;
			varNameLData.heightHint = 60;
			varNameLData.horizontalIndent = 0;
			varNameLData.horizontalSpan = 1;
			varNameLData.verticalSpan = 1;
			varNameLData.grabExcessHorizontalSpace = false;
			varNameLData.grabExcessVerticalSpace = false;
			varName.setLayoutData(varNameLData);
			varName.setSize(new org.eclipse.swt.graphics.Point(583,60));
			final Color varNamebackground = new Color(Display.getDefault(),255,255,255);
			varName.setBackground(varNamebackground);
			final Font varNamefont = new Font(Display.getDefault(),"Courier New",8,0);
			varName.setFont(varNamefont);
	
			varText.setTabs(1);
			final Font varTextfont = new Font(Display.getDefault(),"Courier New",12,0);
			varText.setFont(varTextfont);
			varText.setSize(new org.eclipse.swt.graphics.Point(138,14));
			varText.setBounds(new org.eclipse.swt.graphics.Rectangle(319,32,145,21));
			varText.addKeyListener( new KeyAdapter() {
				public void keyPressed(KeyEvent evt) {
					varTextKeyPressed(evt);
				}
			});
	
			varLabel.setText("Variable Name:");
			varLabel.setSize(new org.eclipse.swt.graphics.Point(145,22));
			varLabel.setBackground(varNamebackground);
			varLabel.setBounds(new org.eclipse.swt.graphics.Rectangle(171,34,145,22));
			final Font varLabelfont = new Font(Display.getDefault(),"Courier New",12,1);
			varLabel.setFont(varLabelfont);
	
			final org.eclipse.swt.graphics.Image imageimage = new org.eclipse.swt.graphics.Image(Display.getDefault(), getClass().getClassLoader().getResourceAsStream("vocleditor/dialogs/fig/newclass_wiz.gif"));
			imageimage.setBackground(image.getBackground());
			image.setImage(imageimage);
			image.setSize(new org.eclipse.swt.graphics.Point(80,60));
			image.setBounds(new org.eclipse.swt.graphics.Rectangle(502,-2,80,60));
	
			Txt.setText("Properties");
			Txt.setSize(new org.eclipse.swt.graphics.Point(145,21));
			Txt.setBackground(varNamebackground);
			Txt.setBounds(new org.eclipse.swt.graphics.Rectangle(91,6,145,21));
			Txt.setFont(varLabelfont);
	
			final org.eclipse.swt.graphics.Image imgLabelimage = new org.eclipse.swt.graphics.Image(Display.getDefault(), getClass().getClassLoader().getResourceAsStream("vocleditor/dialogs/fig/newEEnum_wizR.GIF"));
			imgLabelimage.setBackground(imgLabel.getBackground());
			imgLabel.setImage(imgLabelimage);
			imgLabel.setSize(new org.eclipse.swt.graphics.Point(80,60));
			imgLabel.setBounds(new org.eclipse.swt.graphics.Rectangle(3,-2,80,60));
			varName.setLayout(null);
	
			GridData compositeAMLData = new GridData();
			compositeAMLData.verticalAlignment = GridData.CENTER;
			compositeAMLData.horizontalAlignment = GridData.BEGINNING;
			compositeAMLData.widthHint = 590;
			compositeAMLData.heightHint = 300;
			compositeAMLData.horizontalIndent = 0;
			compositeAMLData.horizontalSpan = 1;
			compositeAMLData.verticalSpan = 1;
			compositeAMLData.grabExcessHorizontalSpace = false;
			compositeAMLData.grabExcessVerticalSpace = false;
			compositeAM.setLayoutData(compositeAMLData);
			compositeAM.setSize(new org.eclipse.swt.graphics.Point(590,300));
	
			GridData attGroupLData = new GridData();
			attGroupLData.verticalAlignment = GridData.CENTER;
			attGroupLData.horizontalAlignment = GridData.BEGINNING;
			attGroupLData.widthHint = 284;
			attGroupLData.heightHint = 295;
			attGroupLData.horizontalIndent = 0;
			attGroupLData.horizontalSpan = 1;
			attGroupLData.verticalSpan = 1;
			attGroupLData.grabExcessHorizontalSpace = false;
			attGroupLData.grabExcessVerticalSpace = false;
			attGroup.setLayoutData(attGroupLData);
			attGroup.setText("Attributes");
			attGroup.setSize(new org.eclipse.swt.graphics.Point(284,295));
			attGroup.setEnabled(true);
			attGroup.setFont(varNamefont);
	
			FormData attributeListLData = new FormData();
			attributeListLData.height = 239;
			attributeListLData.width = 263;
			attributeListLData.left =  new FormAttachment(26, 1000, 0);
			attributeListLData.right =  new FormAttachment(977, 1000, 0);
			attributeListLData.top =  new FormAttachment(31, 1000, 0);
			attributeListLData.bottom =  new FormAttachment(858, 1000, 0);
			attributeList.setLayoutData(attributeListLData);
			attributeList.setSize(new org.eclipse.swt.graphics.Point(263,240));
			attributeList.setEnabled(true);
			attributeList.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					attributeListMouseDown(evt);
				}
			});
	
			FormData editAttributeLData = new FormData();
			editAttributeLData.height = 28;
			editAttributeLData.width = 55;
			editAttributeLData.left =  new FormAttachment(378, 1000, 0);
			editAttributeLData.right =  new FormAttachment(572, 1000, 0);
			editAttributeLData.top =  new FormAttachment(872, 1000, 0);
			editAttributeLData.bottom =  new FormAttachment(968, 1000, 0);
			editAttribute.setLayoutData(editAttributeLData);
			editAttribute.setText("EDIT");
			editAttribute.setSize(new org.eclipse.swt.graphics.Point(55,28));
			editAttribute.setEnabled(false);
			final Font editAttributefont = new Font(Display.getDefault(),"Courier New",10,1);
			editAttribute.setFont(editAttributefont);
			editAttribute.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					editAttributeMouseDown(evt);
				}
			});
	
			FormData addAtributeLData = new FormData();
			addAtributeLData.height = 28;
			addAtributeLData.width = 55;
			addAtributeLData.left =  new FormAttachment(26, 1000, 0);
			addAtributeLData.right =  new FormAttachment(220, 1000, 0);
			addAtributeLData.top =  new FormAttachment(872, 1000, 0);
			addAtributeLData.bottom =  new FormAttachment(968, 1000, 0);
			addAtribute.setLayoutData(addAtributeLData);
			addAtribute.setText("ADD");
			addAtribute.setSize(new org.eclipse.swt.graphics.Point(55,28));
			addAtribute.setEnabled(true);
			addAtribute.setFont(editAttributefont);
			addAtribute.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					addAtributeMouseDown(evt);
				}
			});
	
			FormData removeAttributeLData = new FormData();
			removeAttributeLData.height = 28;
			removeAttributeLData.width = 55;
			removeAttributeLData.left =  new FormAttachment(783, 1000, 0);
			removeAttributeLData.right =  new FormAttachment(977, 1000, 0);
			removeAttributeLData.top =  new FormAttachment(872, 1000, 0);
			removeAttributeLData.bottom =  new FormAttachment(968, 1000, 0);
			removeAttribute.setLayoutData(removeAttributeLData);
			removeAttribute.setText("REMOVE");
			removeAttribute.setSize(new org.eclipse.swt.graphics.Point(55,28));
			removeAttribute.setEnabled(false);
			removeAttribute.setFont(editAttributefont);
			removeAttribute.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					removeAttributeMouseDown(evt);
				}
			});
			FormLayout attGroupLayout = new FormLayout();
			attGroup.setLayout(attGroupLayout);
			attGroupLayout.marginWidth = 0;
			attGroupLayout.marginHeight = 0;
			attGroup.layout();
	
			GridData MethodLData = new GridData();
			MethodLData.verticalAlignment = GridData.CENTER;
			MethodLData.horizontalAlignment = GridData.BEGINNING;
			MethodLData.widthHint = 284;
			MethodLData.heightHint = 295;
			MethodLData.horizontalIndent = 0;
			MethodLData.horizontalSpan = 1;
			MethodLData.verticalSpan = 1;
			MethodLData.grabExcessHorizontalSpace = false;
			MethodLData.grabExcessVerticalSpace = false;
			Method.setLayoutData(MethodLData);
			Method.setText("Set Operation");
			Method.setSize(new org.eclipse.swt.graphics.Point(284,295));
			Method.setFont(varNamefont);
	
			FormData sumButtomLData = new FormData();
			sumButtomLData.height = 38;
			sumButtomLData.width = 57;
			sumButtomLData.left =  new FormAttachment(26, 1000, 0);
			sumButtomLData.right =  new FormAttachment(227, 1000, 0);
			sumButtomLData.top =  new FormAttachment(400, 1000, 0);
			sumButtomLData.bottom =  new FormAttachment(529, 1000, 0);
			sumButtom.setLayoutData(sumButtomLData);
			sumButtom.setText("Sum");
			sumButtom.setSize(new org.eclipse.swt.graphics.Point(57,38));
			sumButtom.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					sumButtomMouseDown(evt);
				}
			});
	
			FormData sumVarComboLData = new FormData();
			sumVarComboLData.height = 21;
			sumVarComboLData.width = 146;
			sumVarComboLData.left =  new FormAttachment(375, 1000, 0);
			sumVarComboLData.right =  new FormAttachment(977, 1000, 0);
			sumVarComboLData.top =  new FormAttachment(613, 1000, 0);
			sumVarComboLData.bottom =  new FormAttachment(687, 1000, 0);
			sumVarCombo.setLayoutData(sumVarComboLData);
			sumVarCombo.setSize(new org.eclipse.swt.graphics.Point(146,21));
			sumVarCombo.setEnabled(false);
			sumVarCombo.addModifyListener( new ModifyListener() {
				public void modifyText(ModifyEvent evt) {
					sumVarComboModifyText(evt);
				}
			});
			sumVarCombo.addKeyListener( new KeyAdapter() {
				public void keyPressed(KeyEvent evt) {
					sumVarComboKeyPressed(evt);
				}
			});
	
			FormData sumVarLabelLData = new FormData();
			sumVarLabelLData.height = 21;
			sumVarLabelLData.width = 75;
			sumVarLabelLData.left =  new FormAttachment(89, 1000, 0);
			sumVarLabelLData.right =  new FormAttachment(353, 1000, 0);
			sumVarLabelLData.top =  new FormAttachment(624, 1000, 0);
			sumVarLabelLData.bottom =  new FormAttachment(694, 1000, 0);
			sumVarLabel.setLayoutData(sumVarLabelLData);
			sumVarLabel.setText("Sum Over:");
			sumVarLabel.setSize(new org.eclipse.swt.graphics.Point(75,20));
			sumVarLabel.setEnabled(false);
	
			FormData noOperationLData = new FormData();
			noOperationLData.height = 31;
			noOperationLData.width = 101;
			noOperationLData.left =  new FormAttachment(26, 1000, 0);
			noOperationLData.right =  new FormAttachment(382, 1000, 0);
			noOperationLData.top =  new FormAttachment(41, 1000, 0);
			noOperationLData.bottom =  new FormAttachment(148, 1000, 0);
			noOperation.setLayoutData(noOperationLData);
			noOperation.setSelection(true);
			noOperation.setText("No SetOperation");
			noOperation.setSize(new org.eclipse.swt.graphics.Point(101,31));
			noOperation.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					noOperationMouseDown(evt);
				}
			});
	
			FormData label1LData = new FormData();
			label1LData.height = 21;
			label1LData.width = 75;
			label1LData.left =  new FormAttachment(89, 1000, 0);
			label1LData.right =  new FormAttachment(353, 1000, 0);
			label1LData.top =  new FormAttachment(519, 1000, 0);
			label1LData.bottom =  new FormAttachment(589, 1000, 0);
			label1.setLayoutData(label1LData);
			label1.setText("Variable Name:");
			label1.setSize(new org.eclipse.swt.graphics.Point(75,20));
			label1.setEnabled(false);
	
			FormData setVarNameLData = new FormData();
			setVarNameLData.height = 19;
			setVarNameLData.width = 158;
			setVarNameLData.left =  new FormAttachment(375, 1000, 0);
			setVarNameLData.right =  new FormAttachment(977, 1000, 0);
			setVarNameLData.top =  new FormAttachment(508, 1000, 0);
			setVarNameLData.bottom =  new FormAttachment(596, 1000, 0);
			setVarName.setLayoutData(setVarNameLData);
			setVarName.setEditable(true);
			setVarName.setSize(new org.eclipse.swt.graphics.Point(158,19));
			setVarName.setEnabled(false);
			setVarName.addKeyListener( new KeyAdapter() {
				public void keyPressed(KeyEvent evt) {
					setVarNameKeyPressed(evt);
				}
			});
	
			FormData setVariableLData = new FormData();
			setVariableLData.height = 31;
			setVariableLData.width = 97;
			setVariableLData.left =  new FormAttachment(26, 1000, 0);
			setVariableLData.right =  new FormAttachment(367, 1000, 0);
			setVariableLData.top =  new FormAttachment(313, 1000, 0);
			setVariableLData.bottom =  new FormAttachment(421, 1000, 0);
			setVariable.setLayoutData(setVariableLData);
			setVariable.setText("Set Size Variable");
			setVariable.setSize(new org.eclipse.swt.graphics.Point(97,32));
			setVariable.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					setVariableMouseDown(evt);
				}
			});
	
			FormData notEmptyLData = new FormData();
			notEmptyLData.height = 32;
			notEmptyLData.width = 74;
			notEmptyLData.left =  new FormAttachment(26, 1000, 0);
			notEmptyLData.right =  new FormAttachment(286, 1000, 0);
			notEmptyLData.top =  new FormAttachment(224, 1000, 0);
			notEmptyLData.bottom =  new FormAttachment(331, 1000, 0);
			notEmpty.setLayoutData(notEmptyLData);
			notEmpty.setText("notEmpty");
			notEmpty.setSize(new org.eclipse.swt.graphics.Point(74,31));
			notEmpty.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					notEmptyMouseDown(evt);
				}
			});
	
			FormData setEmptyLData = new FormData();
			setEmptyLData.height = 32;
			setEmptyLData.width = 70;
			setEmptyLData.left =  new FormAttachment(26, 1000, 0);
			setEmptyLData.right =  new FormAttachment(272, 1000, 0);
			setEmptyLData.top =  new FormAttachment(130, 1000, 0);
			setEmptyLData.bottom =  new FormAttachment(241, 1000, 0);
			setEmpty.setLayoutData(setEmptyLData);
			setEmpty.setText("isEmpty");
			setEmpty.setSize(new org.eclipse.swt.graphics.Point(70,33));
			setEmpty.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					setEmptyMouseDown(evt);
				}
			});
	
			FormData combo1LData = new FormData();
			combo1LData.height = 21;
			combo1LData.width = 146;
			combo1LData.left =  new FormAttachment(375, 1000, 0);
			combo1LData.right =  new FormAttachment(977, 1000, 0);
			combo1LData.top =  new FormAttachment(529, 1000, 0);
			combo1LData.bottom =  new FormAttachment(603, 1000, 0);
			combo1.setLayoutData(combo1LData);
			combo1.setSize(new org.eclipse.swt.graphics.Point(146,21));
			combo1.setEnabled(false);
			FormLayout MethodLayout = new FormLayout();
			Method.setLayout(MethodLayout);
			MethodLayout.marginWidth = 0;
			MethodLayout.marginHeight = 0;
			Method.layout();
			GridLayout compositeAMLayout = new GridLayout(2, true);
			compositeAM.setLayout(compositeAMLayout);
			compositeAMLayout.marginWidth = 5;
			compositeAMLayout.marginHeight = 5;
			compositeAMLayout.numColumns = 2;
			compositeAMLayout.makeColumnsEqualWidth = true;
			compositeAMLayout.horizontalSpacing = 5;
			compositeAMLayout.verticalSpacing = 5;
			compositeAM.layout();
	
			GridData buttonsLData = new GridData();
			buttonsLData.verticalAlignment = GridData.CENTER;
			buttonsLData.horizontalAlignment = GridData.BEGINNING;
			buttonsLData.widthHint = 587;
			buttonsLData.heightHint = 43;
			buttonsLData.horizontalIndent = 0;
			buttonsLData.horizontalSpan = 1;
			buttonsLData.verticalSpan = 1;
			buttonsLData.grabExcessHorizontalSpace = false;
			buttonsLData.grabExcessVerticalSpace = false;
			buttons.setLayoutData(buttonsLData);
			buttons.setSize(new org.eclipse.swt.graphics.Point(587,43));
	
			FormData applyLData = new FormData();
			applyLData.height = 25;
			applyLData.width = 144;
			applyLData.left =  new FormAttachment(731, 1000, 0);
			applyLData.right =  new FormAttachment(977, 1000, 0);
			applyLData.top =  new FormAttachment(197, 1000, 0);
			applyLData.bottom =  new FormAttachment(779, 1000, 0);
			apply.setLayoutData(applyLData);
			apply.setText("CLOSE");
			apply.setSize(new org.eclipse.swt.graphics.Point(144,25));
			apply.setFont(editAttributefont);
			apply.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					applyMouseDown(evt);
				}
			});
			FormLayout buttonsLayout = new FormLayout();
			buttons.setLayout(buttonsLayout);
			buttonsLayout.marginWidth = 0;
			buttonsLayout.marginHeight = 0;
			buttons.layout();
			GridLayout dialogShellLayout = new GridLayout(1, true);
			dialogShell.setLayout(dialogShellLayout);
			dialogShellLayout.marginWidth = 5;
			dialogShellLayout.marginHeight = 5;
			dialogShellLayout.numColumns = 1;
			dialogShellLayout.makeColumnsEqualWidth = true;
			dialogShellLayout.horizontalSpacing = 5;
			dialogShellLayout.verticalSpacing = 5;
			dialogShell.layout();
			dialogShell.addDisposeListener(new DisposeListener() {
				public void widgetDisposed(DisposeEvent e) {
					varNamebackground.dispose();
					varNamefont.dispose();
					varTextfont.dispose();
					varLabelfont.dispose();
					imageimage.dispose();
					imgLabelimage.dispose();
					editAttributefont.dispose();
				}
			});
			Rectangle bounds = dialogShell.computeTrim(0, 0, 600,425);
			dialogShell.setSize(bounds.width, bounds.height);
			postInitGUI();
			dialogShell.open();
			Display display = dialogShell.getDisplay();
			while (!dialogShell.isDisposed()) {
				if (!display.readAndDispatch())
					display.sleep();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/** Add your pre-init code in here 	*/
	public void preInitGUI(){
	}

	/** Add your post-init code in here 	*/
	public void postInitGUI(){
		this.setValues();
		Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
		int x = (int)dim.getWidth();
		int y = (int)dim.getHeight();
		x = x/2 - (dialogShell.getSize().x/2);
		y = y/2 - (dialogShell.getSize().y/2);
		dialogShell.setLocation(x,y);
		
		changes.put(VOCLEditorConstants.ATTRIBUTES,attributesOfClassifierRole);
	}
	
	
	/**
	 * This method sets the Values to the Dialog by reading them form
	 * the ClassifierRole and inserting to the Dialogs elements.
	 * @param clr - the ClassifierRole which properties to show
	 */
	public void setValues() {	
		
			// set the Name and VariableName of this classifier
			String varname   = (String)changes.get(VOCLEditorConstants.CLASS_VAR_NAME);
			String classname = (String)changes.get(VOCLEditorConstants.CLASS_NAME);
			
			dialogShell.setText("SetClassifierRole Properties: " + classname);
			varText.setText(varname);
			
			// here retrieve the set-method, if any and the 
			// related variable-declarations 
			int state = ((Integer)changes.get(VOCLEditorConstants.STATE)).intValue();
			String vn 		= (String)changes.get(VOCLEditorConstants.SET_SIZE_VAR);
			String summand 	= (String)changes.get(VOCLEditorConstants.SUMMAND_VAR);

			// update the local fields with the initialized values
			// globalName = varname;
			if (state >= 0 && state < 5) {
				this.noOperation.setSelection(false);
				this.setState(state);
				this.setVarName.setText(vn);
				this.sumVarCombo.setText(summand);
			}
			
			// add all the attributes to the Dialog
			LinkedList attributes = (LinkedList)changes.get(VOCLEditorConstants.ATTRIBUTES);
			for (int i = 0; i < attributes.size(); i++) {
				AttributeElement att = (AttributeElement)attributes.get(i);
				String name  = att.getAttName();
				String type  = att.getType();
				String value = att.getValue();
				if (att.isVar()) {
					addAttributeToList(name, type, att.getVarname());
				} else {
					addAttributeToList(name, type, value);
				}
				
				attributesOfClassifierRole.add(att);
				if (att.isVar()) {
					String varName = att.getVarname();
					addAttributeToComboBox(varName, type, value);
				}
			}
			
	}


	/**
	* This static method creates a new instance of this class and shows
	* it inside a new Shell.
	*
	* It is a convenience method for showing the GUI, but it can be
	* copied and used as a basis for your own code.	*
	* It is auto-generated code - the body of this method will be
	* re-generated after any changes are made to the GUI.
	* However, if you delete this method it will not be re-created.	*/
	public static void showGUI(){
		try {
			Display display = Display.getDefault();
			Shell shell = new Shell(display);
			SetClassifierPropertyDialog inst = new SetClassifierPropertyDialog(shell, SWT.NULL);
			inst.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/**
	 * Handler for Button Close
	 */
	protected void applyMouseDown(MouseEvent evt) {			
		changed = true;
		changes.put(VOCLEditorConstants.SET_SIZE_VAR, setVarName.getText());
		changes.put(VOCLEditorConstants.CLASS_VAR_NAME, varText.getText());	
		changes.put(VOCLEditorConstants.SUMMAND_VAR, sumVarCombo.getText());
		dialogShell.close();
	}

	/**
	 * Handler for notEmpty
	 */
	protected void notEmptyMouseDown(MouseEvent evt){
		this.setActiveVariable(false,false);
		changes.put(VOCLEditorConstants.STATE, new Integer(OpKind.NOT_EMPTY));
	}

	/**
	 * Handler for Set-Size-Variable
	 */
	protected void setVariableMouseDown(MouseEvent evt){
		this.setActiveVariable(true,false);
		changes.put(VOCLEditorConstants.STATE, new Integer(OpKind.COUNT));
		changes.put(VOCLEditorConstants.SET_SIZE_VAR, setVarName.getText());
	}

	/**
	 * Handler for setEmpty
	 */
	protected void setEmptyMouseDown(MouseEvent evt){
		this.setActiveVariable(false,false);
		changes.put(VOCLEditorConstants.STATE, new Integer(OpKind.EMPTY));
		changes.remove(VOCLEditorConstants.SET_SIZE_VAR);
	}
	
	/**
	 * This method activates or deactivates the 
	 * Variable Setting for Set-Size/Set Sum
	 */
	private void setActiveVariable(boolean value1, boolean value2) {
		label1.setEnabled(value1);
		setVarName.setEnabled(value1);
		sumVarLabel.setEnabled(value2);
		sumVarCombo.setEnabled(value2);
	}
	
	/** 
	 * Handler for NO_OP Button selected
	 */
	protected void noOperationMouseDown(MouseEvent evt){
		this.setActiveVariable(false,false);
		changes.put(VOCLEditorConstants.STATE, new Integer(OpKind.NO_OP));
		changes.remove(VOCLEditorConstants.SET_SIZE_VAR);
	}
	
	/** 
	 * Handler for NO_OP Button selected
	 */
	protected void sumButtomMouseDown(MouseEvent evt){
		this.setActiveVariable(true,true);
		changes.put(VOCLEditorConstants.STATE, new Integer(OpKind.SUM));
	}
	

	/**
	 * When creating the dialog, an initial state
	 * has to be selected.
	 * @param i - the state-code
	 */
	public void setState(int i) {
		// state = i;
		switch (i) {
			case OpKind.EMPTY:
				setEmpty.setSelection(true);
				setActiveVariable(false,false);
				break;
			case OpKind.NOT_EMPTY:
				notEmpty.setSelection(true);
				setActiveVariable(false,false);
				break;
			case OpKind.COUNT:
				setVariable.setSelection(true);
				setActiveVariable(true,false);
				break;
			case OpKind.SUM:
				sumButtom.setSelection(true);
				setActiveVariable(true,true);
				break;
		}
	}


	/** Auto-generated event handler method */
	protected void varTextKeyPressed(KeyEvent evt){
		changes.put(VOCLEditorConstants.CLASS_VAR_NAME, varText.getText());
	}

	/** Auto-generated event handler method */
	protected void text1KeyPressed(KeyEvent evt){
		changes.put(VOCLEditorConstants.SET_SIZE_VAR, setVarName.getText());
	}

	/**
	 * Will return true, if the Apply Button was clicked
	 * @return - changed
	 */
	public boolean hasChanged() {
		return changed;
	}


	/** 
	 * Method invoked by mouseDown-Event from addAttribute
	 * Button. Will open a Dialog where the Attribute 
	 * can be generated.
	 */
	protected void addAtributeMouseDown(MouseEvent evt){
		AddAttributeDialog aad = new AddAttributeDialog(dialogShell,0);
		aad.open();
		
		// check if the apply-button was clicked
		if (!aad.isState()) return;
		
		String attValue = aad.getAttributeValue();
		String attName  = aad.getAttributeName();
		String attType  = aad.getAttributeType();

		AttributeElement attElem=new AttributeElement();
		attElem.setAttName(attName);attElem.setType(attType);
		attElem.setValue(attValue);attElem.setVar(aad.isVariable());
		//add Variable
		if(attElem.isVar()){
			attElem.setVarname(attValue);
		
		}
		attributesOfClassifierRole.add(attElem);
				
		// apdate the List
		addAttributeToList(attName,attType,attValue);
					
	}
	
	/**
	 * This method adds an Attribute to the list, 
	 * specified by name, type and value.
	 * Inserted as Label in the following format:
	 * <name>: "<value>" [<type>]
	 * @param name	- the attributes name
	 * @param type	- the attributes type (e.g. String)
	 * @param value	- the attributes value
	 */
	public void addAttributeToList(String name, String type, String value) {
		String attString = new String(name + ": \"" + value + "\" [" + type + "]");
		attributeList.add(attString);
	}

	/**
	 * This method adds an Attribute to the , combo box
	 * specified by name, type and value.
	 * Type could be used, to allow only Integers (Numbers)
	 * Inserted as Label in the following format:
	 * <name>
	 * @param name	- the attributes name
	 * @param type	- the attributes type (e.g. String)
	 * @param value	- the attributes value
	 */
	public void addAttributeToComboBox(String name, String type, String value) {
		String attString = new String(name);//  + ": \"" + value + "\" [" + type + "]");
		sumVarCombo.add(attString);
	}
	
	/**
	 * A Listentry might be selected
	 */
	protected void attributeListMouseDown(MouseEvent evt){
		updateEnabledButtons();		
	}
	
	
	/**
	 * Checks weather the edit and remove buttons
	 * are appliabe.
	 */
	public void updateEnabledButtons() {
		if (attributeList.getSelectionIndex() > -1) {
			removeAttribute.setEnabled(true);
			editAttribute.setEnabled(true);
		} else {
			removeAttribute.setEnabled(false);
			editAttribute.setEnabled(false);
		}
	}
	

	/**
	 * This Method is invoked when clicking 
	 * the edit Attribute Button. A Dialog is Shown,
	 * which contains all information of the 
	 * Attribute, which can be edited. 
	 */
	protected void editAttributeMouseDown(MouseEvent evt){	
		if(attributeList.getSelectionIndex()== -1)return;	
		
		AttributeElement attElem=(AttributeElement)attributesOfClassifierRole.get(
													attributeList.getSelectionIndex());
		AddAttributeDialog aad = new AddAttributeDialog(dialogShell,0,attElem);
		aad.open();
			
		// check if the apply-button was clicked
		if (!aad.isState())return;
		String attName  = aad.getAttributeName();
		String attValue = aad.getAttributeValue();
		String attType  = aad.getAttributeType();
		attElem.setAttName(attName);attElem.setType(attType);
		attElem.setValue(attValue);attElem.setVar(aad.isVariable());
		if(attElem.isVar())
			attElem.setVarname(attValue);
				
		int index = attributeList.getSelectionIndex();
		attributesOfClassifierRole.set(index,attElem);
		
		//adaptate the List
		changeAttributeOfList(index,attName,attType,attValue);
		this.updateEnabledButtons();	
	}


	/**
	* This method changes an Attribute to the list, 
	* specified by name, type and value.
	* Inserted as Label in the following format:
	* <name>: "<value>" [<type>]
	* @param name	- the attributes name
	* @param type	- the attributes type (e.g. String)
	* @param value	- the attributes value
	*/
	public void changeAttributeOfList(int index, String name, String type, String value) {
		String attString = new String(name + ": \"" + value + "\" [" + type + "]");
		String[] sel = attributeList.getItems();
		sel[index] = attString;
		attributeList.removeAll();
		for (int i = 0; i < sel.length; i++) {
			attributeList.add(sel[i]);
		}
	}

	/**
	 * Invoked, when the rmove Attribute Button was clicked.
	 * Removes the selected Attribute from the GUI and
	 * from the global list (attributesOfClassifierRole)
	 */
	protected void removeAttributeMouseDown(MouseEvent evt){
		if(attributeList.getSelectionIndex()== -1)return;
		int index=attributeList.getSelectionIndex();
		attributeList.remove(index);
		attributesOfClassifierRole.remove(index);
		this.updateEnabledButtons();
	}
	/**
	 * @return
	 */
	public LinkedList getAttributesOfClassifierRole() {
		return attributesOfClassifierRole;
	}



	/**
	 * Updates the setSizeVar, if edited
	 * @param evt - the handled event
	 */
	protected void setVarNameKeyPressed(KeyEvent evt){
		changes.put(VOCLEditorConstants.SET_SIZE_VAR, setVarName.getText());
	}

	/**
	 * Update the local variable for
	 * the set-Summand
	 * @param evt - the handled event
	 */
	protected void sumVarComboKeyPressed(KeyEvent evt){
		changes.put(VOCLEditorConstants.SUMMAND_VAR, sumVarCombo.getText());
	}
	
	
	/**
	 * @param list
	 */
	public void setAttributesOfClassifierRole(LinkedList list) {
		attributesOfClassifierRole = list;
	}


	/**
	 * Update the local variable of the 
	 * SetSummand when modifying the comboBox
	 */
	protected void sumVarComboModifyText(ModifyEvent evt){
		changes.put(VOCLEditorConstants.SUMMAND_VAR, sumVarCombo.getText());
	}
	
	/**
	 * Debug-Method, prints all Objects from the
	 * Hashtable with [key - object] format
	 */
	private void testChanges() {
		Enumeration enums = changes.keys();
		while(enums.hasMoreElements()) {
			String key 		= (String)enums.nextElement();
			Object value 	= changes.get(key);
			System.out.println("Key: " + key + "\tWert: " + value);
		}
	}

	/**
	 * This method retrieves the Hashtable where all
	 * changes/settings are stored inside.
	 * @return - the hashtable with changes/settings
	 */
	public Hashtable getChanges() {
		return changes;
	}

	/**
	 * Sets the initial Values stored inside
	 * the hashTable changes
	 * @param hashtable - the hashtable with all initial
	 * values 
	 */
	public void setChanges(Hashtable hashtable) {
		changes = hashtable;
	}

}
