/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.edit.policy;



import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.requests.ChangeBoundsRequest;

import vocleditor.commands.connect.MoveAssociationEndRoleCommand;
import vocleditor.edit.AssociationEndRoleEditPart;
import vocleditor.edit.AssociationRoleEditPart;
import VOCLModel.AssociationEndRole;


public class AssociationEndRoleMovePolicy extends NonResizableEditPolicy
{
	public Command getMoveCommand(ChangeBoundsRequest request)
	{	
		if (request.getEditParts().get(0) instanceof AssociationEndRoleEditPart)
		{	

			AssociationEndRole model = (AssociationEndRole)getHost().getModel();
			Point delta = request.getMoveDelta();
			MoveAssociationEndRoleCommand command =
				new MoveAssociationEndRoleCommand(model, getParentFigure(), delta);
			return command;
		}
		return null;	 
	}

	public Figure getParentFigure()
	{
		AssociationRoleEditPart edge = (AssociationRoleEditPart)getHost().getParent();
		return (Figure)edge.getFigure();
	}

}
