/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.edit.policy;


import org.eclipse.gef.ConnectionEditPart;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.editpolicies.ConnectionEndpointEditPolicy;

import vocleditor.figure.AssociationRoleFigure;

/**
 * <code>EdgeEndpointEditPolicy</code> provides visual feedback for selected edges. Its
 * superclass, <code>ConnectionEndpointEditPolicy</code> displays selection handles. This
 * class also causes the line width to double when selected.
 * 
 * @author ddean
 *
 */
public class AssociationRoleEndpointEditPolicy extends ConnectionEndpointEditPolicy {

	/**
	 * 
	 */
	public AssociationRoleEndpointEditPolicy() {
		super();
	}

	protected void addSelectionHandles(){
		super.addSelectionHandles();
		getConnectionFigure().setLineWidth(2);
	}

	protected AssociationRoleFigure getConnectionFigure(){
		return (AssociationRoleFigure)((GraphicalEditPart)getHost()).getFigure();
	}

	protected void removeSelectionHandles(){
		super.removeSelectionHandles();
		getConnectionFigure().setLineWidth(1);
	}
	
	public ConnectionEditPart getConnectionEditPart()
	{
		return (ConnectionEditPart)getHost();
	}
}
