/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.edit.policy;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.ComponentEditPolicy;
import org.eclipse.gef.requests.GroupRequest;

import vocleditor.commands.delete.DeleteConstraintCommand;
import VOCLModel.Constraint;
import VOCLModel.VOCLDiagramm;


public class ConstraintComponentEditPolicy
	extends ComponentEditPolicy {

		/**
		 * 
		 */
		public ConstraintComponentEditPolicy() {
			super();
		}

		/* (non-Javadoc)
		 * @see org.eclipse.gef.editpolicies.ComponentEditPolicy#createDeleteCommand(org.eclipse.gef.requests.GroupRequest)
		 */
		protected Command createDeleteCommand(GroupRequest deleteRequest) {
			VOCLDiagramm diagramm = (VOCLDiagramm) getHost().getParent().getModel();
			DeleteConstraintCommand deleteCmd = new DeleteConstraintCommand();
			Constraint constraint=(Constraint) getHost().getModel();
			deleteCmd.setVOCLDiagramm(diagramm);
			deleteCmd.setConstraint(constraint);

			return deleteCmd;
		}


}

