/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.editors.tools;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.requests.CreationFactory;
import org.eclipse.gef.tools.ConnectionCreationTool;
import org.eclipse.swt.widgets.Shell;

import vocleditor.commands.connect.NavConnectCommand;
import vocleditor.dialogs.CreateAssociationDialog;



public class VOCLConnectionCreationTool extends ConnectionCreationTool {
	

	/**
	 * 
	 */
	public VOCLConnectionCreationTool() {super();}

	/**
	 * @param factory
	 */
	public VOCLConnectionCreationTool(CreationFactory factory) {super(factory);}

	/* (non-Javadoc)
	 * @see org.eclipse.gef.tools.AbstractTool#executeCurrentCommand()
	 */
	protected void executeCurrentCommand() {
		Command command=getCurrentCommand();
		Shell shell=this.getCurrentViewer().getControl().getShell();
		if((command instanceof NavConnectCommand) && command.canExecute()){
			if(!openDialogConnect((NavConnectCommand)command,shell))return;
		}
		super.executeCurrentCommand();
	}
	
	
	/**
	 * open the <code>CreateAssociationDialog</code> to create <code>SimpleClassifierRoleEditPart</code>.
	 *
	 * @param command  active <code>CreateLetExpCommand</code>  
	 * @param shell	   the <code>Shell</code> 
	 * @return true if the Dialog was closed with OK Button,else false.
	 */
	private boolean openDialogConnect(NavConnectCommand command,Shell shell){
		CreateAssociationDialog d = new CreateAssociationDialog(shell);
		String name="";
		if(command.getSource().getCallVar()!=null)
			name=command.getSource().getCallVar().getVarName();
		name=name+ ": "+command.getSource().getType();
		d.setSourceName(name);
		name="";
		if(command.getTarget().getCallVar()!=null)
			name=command.getTarget().getCallVar().getVarName();
		name=name+": "+(command.getTarget().getType());
		d.setTargetName(name);
		d.open();
		if(!d.isState())return false;
		command.setSourceName(d.getSourceNav());
		command.setTargetName(d.getTargetNav());	
		return true;

	} 

}
