/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.figure;

import org.eclipse.draw2d.BorderLayout;
import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.Panel;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.TitleBarBorder;

import vocleditor.editors.VOCLEditorConstants;


public class IfExpFigure extends Figure{
	

	/**
	 * 
	 */
	protected Panel ifpanel;
	protected Panel thenpanel;
	protected Panel elsepanel;
	protected VOCLPanel VPanel;
	protected VOCLPanel HPanel;

	
	public IfExpFigure() {
		super();
		setLayoutManager(new BorderLayout());
		setBorder(new LineBorder(ColorConstants.black,2));
		HPanel=new VOCLPanel();
		HPanel.setLayoutManager(new VOCLBorderLayout());
		HPanel.setBorder(new LineBorder(VOCLEditorConstants.titleColor,3));
		add(HPanel,BorderLayout.CENTER);
		
		ifpanel=new Panel();
		TitleBarBorder ifborder=new TitleBarBorder("IF");
		ifborder.setBackgroundColor(VOCLEditorConstants.titleColor);
		ifborder.setTextAlignment(PositionConstants.CENTER);
		ifborder.setFont(VOCLEditorConstants.font);
		ifpanel.setBorder(ifborder);
		ifpanel.setLayoutManager(new BorderLayout());
		HPanel.add(ifpanel,VOCLBorderLayout.TOP);
		
		VPanel=new VOCLPanel();
		VPanel.setLayoutManager(new VOCLBorderLayout());
		HPanel.add(VPanel,BorderLayout.BOTTOM);

		thenpanel=new Panel();
		thenpanel.setLayoutManager(new BorderLayout());
		thenpanel.setLayoutManager(new BorderLayout());
		TitleBarBorder thenborder=new TitleBarBorder("THEN");
		thenborder.setBackgroundColor(VOCLEditorConstants.titleColor);
		thenborder.setTextAlignment(PositionConstants.CENTER);
		thenborder.setFont(VOCLEditorConstants.font);
		thenpanel.setBorder(thenborder);
		VPanel.add(thenpanel,BorderLayout.LEFT);
				
		elsepanel=new Panel();
		elsepanel.setLayoutManager(new BorderLayout());
		TitleBarBorder elseborder=new TitleBarBorder("ELSE");
		elseborder.setBackgroundColor(VOCLEditorConstants.titleColor);
		elseborder.setTextAlignment(PositionConstants.CENTER);
		elseborder.setFont(VOCLEditorConstants.font);
		elsepanel.setBorder(elseborder);
		elsepanel.setLayoutManager(new BorderLayout());
		VPanel.add(elsepanel,BorderLayout.RIGHT);	
		
	
	}


	/**
	 * @return
	 */
	public double getProportionV() {
		return VPanel.getProportion();
	}

	/**
	 * @param d
	 */
	public void setProportionV(double d) {
		VPanel.setProportion(d);	
		thenpanel.validate();
		elsepanel.validate();

	}

	

	/**
	 * @return
	 */
	public Panel getElsepanel() {
		return elsepanel;
	}

	/**
	 * @return
	 */
	public VOCLPanel getHPanel() {
		return HPanel;
	}

	/**
	 * @return
	 */
	public Panel getIfpanel() {
		return ifpanel;
	}

	/**
	 * @return
	 */
	public double getProportionH() {
		return  HPanel.getProportion();
	}

	/**
	 * @return
	 */
	public Panel getThenpanel() {
		return thenpanel;
	}

	/**
	 * @return
	 */
	public VOCLPanel getVPanel() {
		return VPanel;
	}

	/**
	 * @param panel
	 */
	public void setElsepanel(Panel panel) {
		elsepanel = panel;
	}

	/**
	 * @param panel
	 */
	public void setHPanel(VOCLPanel panel) {
		HPanel = panel;
	}

	/**
	 * @param panel
	 */
	public void setIfpanel(Panel panel) {
		ifpanel = panel;
	}

	/**
	 * @param d
	 */
	public void setProportionH(double d) {	
		HPanel.setProportion(d);	
		VPanel.validate();
		ifpanel.validate();
	}

	/**
	 * @param panel
	 */
	public void setThenpanel(Panel panel) {
		thenpanel = panel;
	}

	/**
	 * @param panel
	 */
	public void setVPanel(VOCLPanel panel) {
		VPanel = panel;
	}

}
