/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss 
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.figure;


import org.eclipse.draw2d.BorderLayout;
import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.FreeformLayer;
import org.eclipse.draw2d.FreeformLayout;
import org.eclipse.draw2d.FreeformViewport;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.Panel;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.ScrollPane;
import org.eclipse.draw2d.TitleBarBorder;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.draw2d.geometry.Insets;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.handles.HandleBounds;

import vocleditor.editors.VOCLEditorConstants;

/**
 * @author vilapower
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class NavExpContainerFigure extends Figure implements HandleBounds{


			

	private IFigure pane;
	private IFigure conditionPane;
	private boolean negated = false;
	private ScrollPane scrollpane;
	private TitleBarBorder border;
	private Panel panel;
	private Panel mainpanel;
	
	/**
	 * Creates a new NavExpContainerFigure
	 */
	public NavExpContainerFigure(boolean isNegated) {
			
		mainpanel=new Panel();
		mainpanel.setLayoutManager(new BorderLayout());
		mainpanel.setBorder(new LineBorder(ColorConstants.black,2));
			
		BorderLayout layoutpanel =new BorderLayout(); 
		setLayoutManager(layoutpanel);
		
		panel =new Panel();
		BorderLayout layout =new BorderLayout(); 
		panel.setLayoutManager(layout);
		border=new TitleBarBorder("NOT");
		border.setTextAlignment(PositionConstants.CENTER);
		border.setFont(VOCLEditorConstants.font);
		border.setBackgroundColor(VOCLEditorConstants.negateColor);
		
		scrollpane = new ScrollPane();
		pane = new FreeformLayer();
		pane.setLayoutManager(new FreeformLayout());
		scrollpane.setViewport(new FreeformViewport());
		scrollpane.setContents(pane);
		
		panel.add(scrollpane,BorderLayout.CENTER);
		mainpanel.add(panel,BorderLayout.CENTER);
		
		setBackgroundColor(VOCLEditorConstants.container);
		setOpaque(true);	
		
		conditionPane=new Panel();
		ToolbarLayout conditionLayout = new ToolbarLayout();
		conditionLayout.setVertical(false);
		conditionPane.setLayoutManager(conditionLayout);
		conditionPane.setBackgroundColor(VOCLEditorConstants.container);
		conditionPane.setBorder(new LineBorder(ColorConstants.black,1));
		mainpanel.add(conditionPane,BorderLayout.BOTTOM);
		
		add(mainpanel,BorderLayout.CENTER);
		
		setNegated(isNegated);		
	}


	/*
	* @see org.eclipse.gef.handles.HandleBounds#getHandleBounds()
	*/
   public Rectangle getHandleBounds() {
	   return getBounds().getCropped(new Insets(2,0,2,0));
   }
   
   
	public IFigure getFreeFormPane(){
		return pane;
	}

	public IFigure getConditionPane(){
		return conditionPane;
	}

	/**
	 * @return
	 */
	public boolean isNegated() {
		return negated;
	}

	/**
	 * @param b
	 */
	public void setNegated(boolean b) {
		negated = b;
		PanelLayout();
	}


	protected void PanelLayout() {
		if (negated) {	
			panel.setBorder(border);	
			scrollpane.setBorder(new LineBorder(VOCLEditorConstants.negateColor,3));
		}else {
			panel.setBorder(null);	
			scrollpane.setBorder(null);
		}
		repaint();
	}

}
