/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.figure;

import org.eclipse.draw2d.BorderLayout;
import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.FlowLayout;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.Panel;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.swt.graphics.Image;



/**
 * @author vilapower
 */
public class PredicatContainerFigure extends Figure{
	

	private Panel body;
	private PredicatFigure predicat=new PredicatFigure();
	private int predicatType=0;
	private String iterator=new String();

	/**
	 * Creates a new SelectionContainerFigure
	 */
	public PredicatContainerFigure() {		
		BorderLayout layout =new BorderLayout(); 
		setLayoutManager(layout);
		setOpaque(true);

		body=new Panel();
		body.setLayoutManager(new BorderLayout());
		add(body,BorderLayout.CENTER);	
		add(predicat,BorderLayout.RIGHT);
		initIterator();
		
	}	

	

	/**
	 * @see org.eclipse.draw2d.Figure#getPreferredSize(int, int)
	 */
	public Dimension getPreferredSize(int w, int h) {
		return getSize();
	}
	
	
	/**
	 * @return
	 */
	public Panel getBody() {
		return body;
	}

	/**
	 * @param panel
	 */
	public void setBody(Panel panel) {
		body = panel;
	}
	
	/**
	 * @return
	 */
	public int getPredicatType() {
		return predicatType;
	}

	/**
	 * @param i
	 */
	public void setPredicatType(int i) {
		predicatType = i;
		initIterator();
	}
	
	/**
	 * @return
	 */
	public String getIterator() {
		return iterator;
	}

	/**
	 * @param list
	 */
	public void setIterator(String name) {
		iterator=name;
		initIterator();
	}
	
	private void initIterator(){
		predicat.itPanel.removeAll();		
		Label l=new Label(" "+iterator+" ");
		l.setBorder(new LineBorder(ColorConstants.black,1));
		l.setLabelAlignment(PositionConstants.LEFT);
		predicat.itPanel.add(l);			

		Image forallImage;
		if(predicatType==1){
			forallImage = new Image(null, 
				PredicatContainerFigure.class.getResourceAsStream("gif/exists.gif"));
		}else{
			forallImage = new Image(null, 
				PredicatContainerFigure.class.getResourceAsStream("gif/forall.gif"));			
		}
		predicat.lab.setIcon(forallImage);
		predicat.lab.setBorder(new LineBorder(ColorConstants.black,2));
		predicat.lab.setLabelAlignment(PositionConstants.LEFT);
		predicat.itPanel.add(predicat.lab);
		predicat.revalidate();
		
	}


	private class PredicatFigure extends Figure{
		private Label lab=new Label();;
		private Panel itPanel;
		
		private PredicatFigure(){
			BorderLayout layout =new BorderLayout(); 
			setLayoutManager(layout);
			setPreferredSize(new Dimension(0,0));
			setOpaque(true);
			
			itPanel=new Panel();
			itPanel.setLayoutManager(new FlowLayout(false));
			Panel rect=new Panel();
			rect.setOpaque(true);
			add(rect,BorderLayout.CENTER);
			add(itPanel,BorderLayout.BOTTOM);
		}
		
		/**
			 * Retrieving the wanted Dimension for this figure.
			 * It is (0,0) if no operation on this set is
			 * specified.
			 */
		public Dimension getPreferredSize(int wHint, int hHint) {

			return itPanel.getPreferredSize();
		}
	}

}