/*
 * Created on 13.10.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package vocleditor.model;

import java.util.Hashtable;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import VOCLModel.AssociationEndRoleSource;
import VOCLModel.AssociationEndRoleTarget;
import VOCLModel.AssociationNav;
import VOCLModel.AssociationRole;
import VOCLModel.Attribute;
import VOCLModel.BoolExp;
import VOCLModel.ClassifierNode;
import VOCLModel.ClassifierRole;
import VOCLModel.IfExp;
import VOCLModel.LetExp;
import VOCLModel.Method;
import VOCLModel.NavExpContainer;
import VOCLModel.OpKind;
import VOCLModel.PredicateContainer;
import VOCLModel.SetClassifierRole;
import VOCLModel.VOCLExpression;
import VOCLModel.VOCLModel4Factory;
import VOCLModel.VOCLSash;
import VOCLModel.VariableDeclaration;

/**
 * @author eddi
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class DublicateExpression {
	
	public List oldvardec=new LinkedList();
	public List newvardec=new LinkedList();
	
	public IsIn newIsIn=new IsIn();
	public IsIn oldIsIn=new IsIn();

	private VOCLModel4Factory mfc = VOCLModelManager.getFactory();

	private Hashtable clTable=new Hashtable();

	/**
	 * 
	 */
	public DublicateExpression( ) {	}

	public void dublicateContainer(NavExpContainer necon,
			 					   NavExpContainer navexpContainer){
		
		dublicateNavExpContainer(necon, navexpContainer);
		dublicateAssociations(clTable,necon,navexpContainer);
		
	}
	
	
	public void dublicateNavExpContainer(NavExpContainer necon,
										 NavExpContainer navexpContainer){
		
		// setting the attributes of a VOCL Expression
		necon.setIsNegated(navexpContainer.isIsNegated());
		necon.setExptype(navexpContainer.getExptype());	
		//copy ClassifierNodes with VriableDeclaration		
		dublicateClassifierNode(necon,navexpContainer);
		//end of copy
	}
	
	private void createClassifierNode(ClassifierNode newNode,ClassifierNode oldNode,NavExpContainer necon){
		newNode.setType(oldNode.getType());
		newNode.setX(oldNode.getX());
		newNode.setY(oldNode.getY());
		necon.getClassifierNode().add(newNode);
		clTable.put(oldNode,newNode);
		duplicateAttribute(oldNode,newNode);
	}
	
	private void dublicateClassifierNode(NavExpContainer necon,
			 							NavExpContainer navexpContainer){
		Iterator it=navexpContainer.getClassifierNode().iterator();
		while(it.hasNext()){
			ClassifierNode cl=(ClassifierNode) it.next();
			if(cl instanceof ClassifierRole){
				ClassifierRole scl=mfc.createClassifierRole();
				createClassifierNode(scl,cl,necon);
				
				
				if(cl.getCallVar()!=null){
					if(cl.getCallVar().getPredicateContainer()!=null){
						
						SetClassifierRole key=cl.getCallVar().
												getPredicateContainer().getPredicat();
						SetClassifierRole bcl;
						if(clTable.containsKey(key))bcl=(SetClassifierRole) clTable.get(key);
						else{ 
							bcl=key;
							oldIsIn.addAndDeleteIsIn(key,(ClassifierRole)cl,(NavExpContainer) key.eContainer());
							newIsIn.addAndCreateIsIn(key,scl,(NavExpContainer) key.eContainer());
						}
						VariableDeclaration iterVariable=bcl.getPredicateContainer().getIterator();
						scl.setCallVar(iterVariable);
					}else{
						VariableDeclaration var = mfc.createVariableDeclaration();
						dublicateVariableDeclaration(var, cl.getCallVar());
						scl.setCallVar(var);
					}
				}
				duplicateMethod( (ClassifierRole) cl,scl);
			}else{
				SetClassifierRole ccl=mfc.createSetClassifierRole();
				createClassifierNode(ccl,cl,necon);
				if(cl.getCallVar()!=null){
					VariableDeclaration var = mfc.createVariableDeclaration();
					dublicateVariableDeclaration(var, cl.getCallVar());
					ccl.setCallVar(var);
				}
				duplicateOperation((SetClassifierRole) cl,ccl);
				PredicateContainer p = ((SetClassifierRole)cl).getPredicateContainer();
				if (p != null){	
					PredicateContainer newP = mfc.createPredicateContainer();
					dublicatePredicatContainer(newP,p, necon, ccl);
					newP.setPredicat(ccl);					
				}
			}
		}
	}
	
	
	// dublicating a Variable Declaration
	private void dublicateVariableDeclaration(VariableDeclaration newVar, VariableDeclaration oldVar){
		newVar.setVarName(oldVar.getVarName());
		newVar.setType(oldVar.getType());
		oldvardec.add(oldVar);
		newvardec.add(newVar);
	}
	
	
	private void duplicateAttribute(ClassifierNode nodeOld,ClassifierNode nodeNew){
		Iterator it=nodeOld.getAttribute().iterator();
		while(it.hasNext()){
			Attribute att=(Attribute) it.next();
			Attribute attNew=mfc.createAttribute();
			attNew.setName(att.getName());
			attNew.setType(att.getType());
			attNew.setValue(att.getValue());
			nodeNew.getAttribute().add(attNew);
			if(att.getVariableDeclaration()!=null){
				VariableDeclaration var=mfc.createVariableDeclaration();
				dublicateVariableDeclaration(var, att.getVariableDeclaration());
				attNew.setVariableDeclaration(var);		
			}
		}
	}

	
	private void duplicateOperation(SetClassifierRole nodeOld,SetClassifierRole nodeNew){
		switch(nodeOld.getOpKind().getValue()){
		case OpKind.NO_OP:
			return;
		case OpKind.EMPTY:
			nodeNew.setOpKind(OpKind.EMPTY_LITERAL);
			break;
		case OpKind.NOT_EMPTY:
			nodeNew.setOpKind(OpKind.NOT_EMPTY_LITERAL);
			break;
		case OpKind.COUNT:
			nodeNew.setOpKind(OpKind.COUNT_LITERAL);
			VariableDeclaration var=mfc.createVariableDeclaration();
			dublicateVariableDeclaration(var, nodeOld.getOpVar());
			nodeNew.setOpVar(var);
			break;
		case OpKind.SUM:
			nodeNew.setOpKind(OpKind.SUM_LITERAL);
			VariableDeclaration opvar=mfc.createVariableDeclaration();
			dublicateVariableDeclaration(opvar, nodeOld.getOpVar());
			nodeNew.setOpVar(opvar);
			
			VariableDeclaration itvar=mfc.createVariableDeclaration();
			dublicateVariableDeclaration(itvar, nodeOld.getIteratorVar());
			nodeNew.setIteratorVar(itvar);
			break;
		}
	}
	
	private void duplicateMethod(ClassifierRole nodeOld,ClassifierRole nodeNew){
		if(nodeOld.getMethod()==null)return;
		Method metOld=nodeOld.getMethod();
		Method metNew=mfc.createMethod();
		metNew.setName(metOld.getName());
		metNew.setType(metOld.getType());
		nodeNew.setMethod(metNew);
		if(metOld.getRReturn()!=null){
			VariableDeclaration var=mfc.createVariableDeclaration();
			dublicateVariableDeclaration(var,metOld.getRReturn());
			metNew.setRReturn(var);		
		}		
		Iterator it=metOld.getCall().iterator();
		while(it.hasNext()){
			VariableDeclaration var=mfc.createVariableDeclaration();
			dublicateVariableDeclaration(var,(VariableDeclaration) it.next());
			metNew.getCall().add(var);
		}	
	}
	
	private void dublicateAssociations(Hashtable clTable,NavExpContainer necon,
												 NavExpContainer navexpContainer){
		// VOCLModelFactory mfc = VOCLModelManager.getFactory();
		Iterator it=navexpContainer.getAssociationRole().iterator();
		while(it.hasNext()){
			AssociationRole ass=(AssociationRole) it.next();
			AssociationRole newass;
			//Association Fallunterscheidung
			if(ass instanceof AssociationNav){newass=mfc.createAssociationNav();
			}else{newass=mfc.createAssociationIsIn();}
			
			AssociationEndRoleSource assers=mfc.createAssociationEndRoleSource();
			AssociationEndRoleTarget assERTar=mfc.createAssociationEndRoleTarget();

			necon.getAssociationRole().add(newass);
			
			assers.setName(ass.getSource().getName());
			assers.setX(ass.getSource().getX());
			assers.setY(ass.getSource().getY());
			newass.setSource(assers);
			assers.setAssociationRole(newass);
			assers.setNumberOfAnchor(ass.getSource().getNumberOfAnchor());	
				
			assERTar.setName(ass.getTarget().getName());
			assERTar.setX(ass.getTarget().getX());
			assERTar.setY(ass.getTarget().getY());			
			newass.setTarget(assERTar);
			assERTar.setAssociationRole(newass);
			assERTar.setNumberOfAnchor(ass.getTarget().getNumberOfAnchor());
				
			ClassifierNode clTarget=(ClassifierNode)clTable.get(ass.getTarget().getType());
			ClassifierNode clSource=(ClassifierNode)clTable.get(ass.getSource().getType());
			clSource.getSource().add(assers);
			clTarget.getTarget().add(assERTar);
			assers.setType(clSource);	
			assERTar.setType(clTarget);	
		}
	}

	//dublicate PredicatContainer necon is a duble ,navexpCcontaier is to copy
	private void dublicatePredicatContainer(PredicateContainer newPredicat,PredicateContainer oldPredicat,
											NavExpContainer necon,SetClassifierRole scl){

		newPredicat.setPredicat(scl);
		newPredicat.setX(oldPredicat.getX());
		newPredicat.setY(oldPredicat.getY());
		newPredicat.setWidth(oldPredicat.getWidth());
		newPredicat.setHeight(oldPredicat.getHeight());
		newPredicat.setPredType(oldPredicat.getPredType());
		
	
		// dublicate Iterator
		VariableDeclaration it = oldPredicat.getIterator();
		VariableDeclaration newIt = mfc.createVariableDeclaration();
		dublicateVariableDeclaration(newIt, it);		
		newPredicat.setIterator(newIt);
				
		necon.setPredicateContainer(newPredicat);
		
		VOCLExpression innerExp=oldPredicat.getVOCLExpression();
		VOCLExpression newInnerExp = dubInnerExp(innerExp);
		newPredicat.setVOCLExpression(newInnerExp);				
	}
	
	//dublicate BoolExpression
	private void dublicateBoolExpression(BoolExp dubboolexp,BoolExp boolexp){
		dubboolexp.setKind(boolexp.getKind());
		dubboolexp.setExptype(boolexp.getExptype());
		dubboolexp.setIsNegated(boolexp.isIsNegated());
		dubboolexp.setProportion(boolexp.getProportion());
		VOCLModel4Factory mfc = VOCLModelManager.getFactory();
		VOCLSash sash=mfc.createVOCLSash();
		sash.setVertikal(boolexp.getVOCLSash().isVertikal());
		dubboolexp.setVOCLSash(sash);
		
		// creating the 2 inner expressions
		// inner Op1 Expression
		VOCLExpression innerOp1Exp=boolexp.getOp1();
		VOCLExpression newInnerOp1Exp = dubInnerExp(innerOp1Exp);
		dubboolexp.setOp1(newInnerOp1Exp);
		
		//	inner Op2 Expression
		VOCLExpression innerOp2Exp=boolexp.getOp2();
		VOCLExpression newInnerOp2Exp = dubInnerExp(innerOp2Exp);
		dubboolexp.setOp2(newInnerOp2Exp);		
	}

	//dublicate LetExpression
	private void dublicateLetExpression(LetExp dubletexp,LetExp letexp){
		dubletexp.setExptype(letexp.getExptype());
		dubletexp.setIsNegated(letexp.isIsNegated());
		dubletexp.setProportion(letexp.getProportion());
		VOCLModel4Factory mfc = VOCLModelManager.getFactory();
		VOCLSash sash=mfc.createVOCLSash();
		sash.setVertikal(letexp.getVOCLSash().isVertikal());
		dubletexp.setVOCLSash(sash);
		
		VariableDeclaration var=mfc.createVariableDeclaration();
		var.setVarName(letexp.getVariableDeclaration().getVarName());
		var.setType(letexp.getVariableDeclaration().getType());
		dubletexp.setVariableDeclaration(var);
		
		// creating the 2 inner expressions	
		// inner LetExpression
		VOCLExpression innerLetExp=letexp.getLetExpression();
		VOCLExpression newInnerLetExp =  dubInnerExp(innerLetExp);
		dubletexp.setLetExpression(newInnerLetExp);
		
		//	inner in-Expression
		VOCLExpression innerInExp=letexp.getInExpression();
		VOCLExpression newInnerInExp = dubInnerExp(innerInExp);
		dubletexp.setInExpression(newInnerInExp);			
	}

	// dublicate IfExpression
	private void dublicateIfExpression(IfExp dubIfExp,IfExp ifExp){
		// setting all attributes
		dubIfExp.setExptype(ifExp.getExptype());
		dubIfExp.setIsNegated(ifExp.isIsNegated());
		dubIfExp.setProportionH(ifExp.getProportionH());
		dubIfExp.setProportionV(ifExp.getProportionV());
		
		// creating a vertical sash
		VOCLSash sashV=mfc.createVOCLSash();
		sashV.setVertikal(true);
		dubIfExp.setVertikal(sashV);
		
		// creating the horizontal sash
		VOCLSash sashH=mfc.createVOCLSash();
		sashH.setVertikal(false);
		dubIfExp.setVertikal(sashH);
		
		// creating the 3 inner expressions
		// inner IfExpression
		VOCLExpression innerIfExp=ifExp.getIfExpression();
		VOCLExpression newInnerIfExp = dubInnerExp(innerIfExp);
		dubIfExp.setIfExpression(newInnerIfExp);
		
		//	 inner ThenExpression
		VOCLExpression innerThenExp=ifExp.getThenExpression();
		VOCLExpression newInnerThenExp = dubInnerExp(innerThenExp);
		dubIfExp.setIfExpression(newInnerThenExp);
		
		//	 inner ElseExpression
		VOCLExpression innerElseExp=ifExp.getElseExpression();
		VOCLExpression newInnerElseExp = dubInnerExp(innerElseExp);
		dubIfExp.setIfExpression(newInnerElseExp);			
	}
	
	private VOCLExpression dubInnerExp(VOCLExpression innerExp){
		// VOCLModelFactory mfc = VOCLModelManager.getFactory();
		VOCLExpression newInnerExp =null;
		// Navigation Expression Container
		if(innerExp instanceof NavExpContainer){ 	
			newInnerExp = mfc.createNavExpContainer();
			dublicateNavExpContainer((NavExpContainer) newInnerExp,(NavExpContainer)innerExp);
			
		// Boolean Expression Container
		}else if(innerExp instanceof BoolExp){
			newInnerExp = mfc.createBoolExp();
			dublicateBoolExpression((BoolExp) newInnerExp,(BoolExp)innerExp);		
			
		// Let Expression Container
		}else if(innerExp instanceof LetExp){	
			newInnerExp = mfc.createLetExp();
			dublicateLetExpression((LetExp) newInnerExp,(LetExp)innerExp);
		
		// If Expression Container
		}else if(innerExp instanceof IfExp){
			newInnerExp = mfc.createIfExp();
			dublicateIfExpression((IfExp) newInnerExp,(IfExp)innerExp);
		}		
		return newInnerExp;		
	}

	/**
	 * @return Returns the newIsIn.
	 */
	public IsIn getNewIsIn() {
		return newIsIn;
	}
	/**
	 * @param newIsIn The newIsIn to set.
	 */
	public void setNewIsIn(IsIn newIsIn) {
		this.newIsIn = newIsIn;
	}
	/**
	 * @return Returns the oldIsIn.
	 */
	public IsIn getOldIsIn() {
		return oldIsIn;
	}
	/**
	 * @param oldIsIn The oldIsIn to set.
	 */
	public void setOldIsIn(IsIn oldIsIn) {
		this.oldIsIn = oldIsIn;
	}
}
