/**
 * <copyright>
 * </copyright>
 *
 * $Id: VOCLModel4Switch.java,v 1.3 2004/11/03 15:19:10 frank Exp $
 */
package VOCLModel.util;

import VOCLModel.*;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see VOCLModel.VOCLModel4Package
 * @generated
 */
public class VOCLModel4Switch
{
  /**
   * The cached model package
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static VOCLModel4Package modelPackage;

  /**
   * Creates an instance of the switch.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VOCLModel4Switch()
  {
    if (modelPackage == null)
    {
      modelPackage = VOCLModel4Package.eINSTANCE;
    }
  }

  /**
   * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the first non-null result returned by a <code>caseXXX</code> call.
   * @generated
   */
  public Object doSwitch(EObject theEObject)
  {
    return doSwitch(theEObject.eClass(), theEObject);
  }

  /**
   * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the first non-null result returned by a <code>caseXXX</code> call.
   * @generated
   */
  protected Object doSwitch(EClass theEClass, EObject theEObject)
  {
    if (theEClass.eContainer() == modelPackage)
    {
      return doSwitch(theEClass.getClassifierID(), theEObject);
    }
    else
    {
      List eSuperTypes = theEClass.getESuperTypes();
      return
        eSuperTypes.isEmpty() ?
          defaultCase(theEObject) :
          doSwitch((EClass)eSuperTypes.get(0), theEObject);
    }
  }

  /**
   * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the first non-null result returned by a <code>caseXXX</code> call.
   * @generated
   */
  protected Object doSwitch(int classifierID, EObject theEObject)
  {
    switch (classifierID)
    {
      case VOCLModel4Package.ATTRIBUTE:
      {
        Attribute attribute = (Attribute)theEObject;
        Object result = caseAttribute(attribute);
        if (result == null) result = caseModelElement(attribute);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModel4Package.ASSOCIATION_END_ROLE_SOURCE:
      {
        AssociationEndRoleSource associationEndRoleSource = (AssociationEndRoleSource)theEObject;
        Object result = caseAssociationEndRoleSource(associationEndRoleSource);
        if (result == null) result = caseAssociationEndRole(associationEndRoleSource);
        if (result == null) result = caseModelElement(associationEndRoleSource);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModel4Package.ASSOCIATION_END_ROLE_TARGET:
      {
        AssociationEndRoleTarget associationEndRoleTarget = (AssociationEndRoleTarget)theEObject;
        Object result = caseAssociationEndRoleTarget(associationEndRoleTarget);
        if (result == null) result = caseAssociationEndRole(associationEndRoleTarget);
        if (result == null) result = caseModelElement(associationEndRoleTarget);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModel4Package.CLASSIFIER_ROLE:
      {
        ClassifierRole classifierRole = (ClassifierRole)theEObject;
        Object result = caseClassifierRole(classifierRole);
        if (result == null) result = caseClassifierNode(classifierRole);
        if (result == null) result = caseModelElement(classifierRole);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModel4Package.SET_CLASSIFIER_ROLE:
      {
        SetClassifierRole setClassifierRole = (SetClassifierRole)theEObject;
        Object result = caseSetClassifierRole(setClassifierRole);
        if (result == null) result = caseClassifierNode(setClassifierRole);
        if (result == null) result = caseModelElement(setClassifierRole);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModel4Package.METHOD:
      {
        Method method = (Method)theEObject;
        Object result = caseMethod(method);
        if (result == null) result = caseModelElement(method);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModel4Package.NAV_EXP_CONTAINER:
      {
        NavExpContainer navExpContainer = (NavExpContainer)theEObject;
        Object result = caseNavExpContainer(navExpContainer);
        if (result == null) result = caseVOCLExpression(navExpContainer);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModel4Package.CONSTRAINT:
      {
        Constraint constraint = (Constraint)theEObject;
        Object result = caseConstraint(constraint);
        if (result == null) result = caseModelElement(constraint);
        if (result == null) result = caseVOCLExpression(constraint);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModel4Package.CONTEXT:
      {
        Context context = (Context)theEObject;
        Object result = caseContext(context);
        if (result == null) result = caseModelElement(context);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModel4Package.VOCL_DIAGRAMM:
      {
        VOCLDiagramm voclDiagramm = (VOCLDiagramm)theEObject;
        Object result = caseVOCLDiagramm(voclDiagramm);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModel4Package.LET_EXP:
      {
        LetExp letExp = (LetExp)theEObject;
        Object result = caseLetExp(letExp);
        if (result == null) result = caseVOCLExpression(letExp);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModel4Package.IF_EXP:
      {
        IfExp ifExp = (IfExp)theEObject;
        Object result = caseIfExp(ifExp);
        if (result == null) result = caseVOCLExpression(ifExp);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModel4Package.BOOL_EXP:
      {
        BoolExp boolExp = (BoolExp)theEObject;
        Object result = caseBoolExp(boolExp);
        if (result == null) result = caseVOCLExpression(boolExp);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModel4Package.VOCL_SASH:
      {
        VOCLSash voclSash = (VOCLSash)theEObject;
        Object result = caseVOCLSash(voclSash);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModel4Package.CONDITION:
      {
        Condition condition = (Condition)theEObject;
        Object result = caseCondition(condition);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModel4Package.VARIABLE_DECLARATION:
      {
        VariableDeclaration variableDeclaration = (VariableDeclaration)theEObject;
        Object result = caseVariableDeclaration(variableDeclaration);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModel4Package.PREDICATE_CONTAINER:
      {
        PredicateContainer predicateContainer = (PredicateContainer)theEObject;
        Object result = casePredicateContainer(predicateContainer);
        if (result == null) result = caseVOCLExpression(predicateContainer);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModel4Package.ASSOCIATION_IS_IN:
      {
        AssociationIsIn associationIsIn = (AssociationIsIn)theEObject;
        Object result = caseAssociationIsIn(associationIsIn);
        if (result == null) result = caseAssociationRole(associationIsIn);
        if (result == null) result = caseModelElement(associationIsIn);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModel4Package.ASSOCIATION_NAV:
      {
        AssociationNav associationNav = (AssociationNav)theEObject;
        Object result = caseAssociationNav(associationNav);
        if (result == null) result = caseAssociationRole(associationNav);
        if (result == null) result = caseModelElement(associationNav);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      default: return defaultCase(theEObject);
    }
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Model Element</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Model Element</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseModelElement(ModelElement object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Attribute</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Attribute</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseAttribute(Attribute object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Association Role</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Association Role</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseAssociationRole(AssociationRole object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Association End Role</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Association End Role</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseAssociationEndRole(AssociationEndRole object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Classifier Node</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Classifier Node</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseClassifierNode(ClassifierNode object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Association End Role Source</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Association End Role Source</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseAssociationEndRoleSource(AssociationEndRoleSource object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Association End Role Target</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Association End Role Target</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseAssociationEndRoleTarget(AssociationEndRoleTarget object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Classifier Role</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Classifier Role</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseClassifierRole(ClassifierRole object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Set Classifier Role</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Set Classifier Role</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseSetClassifierRole(SetClassifierRole object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Method</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Method</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseMethod(Method object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Nav Exp Container</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Nav Exp Container</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseNavExpContainer(NavExpContainer object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Constraint</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Constraint</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseConstraint(Constraint object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Context</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Context</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseContext(Context object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>VOCL Diagramm</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>VOCL Diagramm</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseVOCLDiagramm(VOCLDiagramm object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>VOCL Expression</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>VOCL Expression</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseVOCLExpression(VOCLExpression object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Let Exp</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Let Exp</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseLetExp(LetExp object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>If Exp</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>If Exp</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseIfExp(IfExp object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Bool Exp</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Bool Exp</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseBoolExp(BoolExp object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>VOCL Sash</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>VOCL Sash</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseVOCLSash(VOCLSash object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Condition</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Condition</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseCondition(Condition object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Variable Declaration</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Variable Declaration</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseVariableDeclaration(VariableDeclaration object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Predicate Container</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Predicate Container</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object casePredicateContainer(PredicateContainer object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Association Is In</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Association Is In</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseAssociationIsIn(AssociationIsIn object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Association Nav</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Association Nav</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseAssociationNav(AssociationNav object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>EObject</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch, but this is the last case anyway.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>EObject</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject)
   * @generated
   */
  public Object defaultCase(EObject object)
  {
    return null;
  }

} //VOCLModel4Switch
